spool c:\tfc\tablas.log

REM  INICAMOS ELPROCESO DE BORRADO DE POSIBLES TABLAS

DROP TABLE TF2.T_LOG;

DROP TABLE TF2.T_ESTADISTICA1;

DROP TABLE TF2.T_ESTADISTICA2;

DROP TABLE TF2.T_ESTADISTICA3;

DROP TABLE TF2.T_ESTADISTICA4;

DROP TABLE TF2.T_ESTADISTICA5;

DROP TABLE TF2.T_ESTADISTICA6;

DROP TABLE TF2.T_ESTADISTICA7;

DROP TABLE TF2.T_CONTADOR CASCADE CONSTRAINTS;

DROP TABLE TF2.T_MODELO CASCADE CONSTRAINTS;
 
DROP TABLE TF2.T_LECTURAS CASCADE CONSTRAINTS;

DROP TABLE TF2.T_DIRECCIONES CASCADE CONSTRAINTS;

DROP TABLE TF2.T_CON_CENTRALES CASCADE CONSTRAINTS;

DROP TABLE TF2.T_CLIENTES CASCADE CONSTRAINTS;

DROP TABLE TF2.T_CLIENTECONTADOR CASCADE CONSTRAINTS;
 
DROP TABLE TF2.T_CENTRALESDISTRIBUCION CASCADE CONSTRAINTS;

DROP TABLE TF2.T_CENTRALESPRODUCCION CASCADE CONSTRAINTS;

DROP TABLE TF2.T_PRODUC_DIS CASCADE CONSTRAINTS;

DROP TABLE TF2.T_TIPOCENTRAL CASCADE CONSTRAINTS;

DROP TABLE TF2.T_LINEASCOMUNIC CASCADE CONSTRAINTS;



/




REM INICIAMOS LA CREACIN COMPLETA DE TABLAS 



REM TF2 T_LOG

  CREATE TABLE "TF2"."T_LOG" 
   (	"ID_LOG" NUMBER, 
	"FECHA" DATE NOT NULL ENABLE, 
	"PROCEDIMIENTO" VARCHAR2(200 BYTE) NOT NULL ENABLE, 
	"ENTRADA" VARCHAR2(2000 BYTE) NOT NULL ENABLE, 
	"SALIDA" VARCHAR2(2000 BYTE) NOT NULL ENABLE, 
	"RESULTADO" VARCHAR2(1000 BYTE), 
	 CONSTRAINT "T_LOG_PK" PRIMARY KEY ("ID_LOG") ENABLE
   ) ;
 
/
/* CREAMOS TABLAS DEL MODULO ESTADISTICA*/


/

REM TF2 T_ESTADISTICA1

  CREATE TABLE "TF2"."T_ESTADISTICA1" 
   (	"ID_E1" NUMBER, 
	"ID_CENTRALPROD" NUMBER NOT NULL ENABLE, 
	"CONSUM_TOTAL" NUMBER(10,3) DEFAULT 0 NOT NULL ENABLE, 
	 CONSTRAINT "T_ESTADISTICA1_PK" PRIMARY KEY ("ID_E1") ENABLE
   ) ;
 
/


REM TF2 T_ESTADISTICA2

  CREATE TABLE "TF2"."T_ESTADISTICA2" 
   (	"ID_E2" VARCHAR2(4000 BYTE) NOT NULL ENABLE, 
	"ANO1" NUMBER(4,0), 
	"ID_LINEACOM" NUMBER, 
	"CONSUMOMEDIO" VARCHAR2(4000 BYTE), 
	"CONSUMOTOT" NUMBER, 
	 CONSTRAINT "T_ESTADISTICA2_PK" PRIMARY KEY ("ID_E2") ENABLE 
   ) ;
 

/


REM TF2 T_ESTADISTICA3

  CREATE TABLE "TF2"."T_ESTADISTICA3" 
   (	"ID_E3" NUMBER, 
	"ID_LINEACOM" NUMBER, 
	"TOPCONSUMO" NUMBER(10,3), 
	 CONSTRAINT "T_ESTADISTICA3_PK" PRIMARY KEY ("ID_E3") ENABLE
   ) ;
 
/


REM TF2 T_ESTADISTICA4

  CREATE TABLE "TF2"."T_ESTADISTICA4" 
   (	"ID_E4" NUMBER, 
	"ANO2" NUMBER(4,0), 
	"TOTAL_LINEAS" VARCHAR2(4000 BYTE), 
	"LINEAS50CON" NUMBER, 
	"PORCENTAJE" NUMBER, 
	 CONSTRAINT "T_ESTADISTICA4_PK" PRIMARY KEY ("ID_E4") ENABLE, 
	 CONSTRAINT "T_ESTADISTICA4_UK1" UNIQUE ("ANO2") ENABLE
   ) ;
 
/


REM TF2 T_ESTADISTICA5

  CREATE TABLE "TF2"."T_ESTADISTICA5" 
   (	"ID_E5" NUMBER, 
	"ANO3" NUMBER(4,0), 
	"CENTRALESMIN30" NUMBER, 
	 CONSTRAINT "T_ESTADISTICA5_PK" PRIMARY KEY ("ID_E5") ENABLE, 
	 CONSTRAINT "T_ESTADISTICA5_UK1" UNIQUE ("ANO3") ENABLE
   ) ;
 

/


REM TF2 T_ESTADISTICA6

  CREATE TABLE "TF2"."T_ESTADISTICA6" 
   (	"ID_E6" NUMBER, 
	"CODCONTA" VARCHAR2(12 BYTE), 
	"LECTURA" NUMBER(10,3), 
	 CONSTRAINT "T_ESTADISTICA6_PK" PRIMARY KEY ("ID_E6") ENABLE
   ) ;
 
/


REM TF2 T_ESTADISTICA7

  CREATE TABLE "TF2"."T_ESTADISTICA7" 
   (	"ID_E7" NUMBER, 
	"CONTA_CONSUMOMEDIO" NUMBER(10,3), 
	 CONSTRAINT "T_ESTADISTICA7_PK" PRIMARY KEY ("ID_E7") ENABLE
   ) ;
 
/


REM TF2 T_DIRECCIONES

  CREATE TABLE "TF2"."T_DIRECCIONES" 
   (	"ID_DIRECCION" NUMBER, 
	"PAIS" VARCHAR2(30 BYTE) NOT NULL ENABLE, 
	"LOCALIDAD" VARCHAR2(30 BYTE) NOT NULL ENABLE, 
	"CODIGOPOSTAL" NUMBER NOT NULL ENABLE, 
	"TIPO_VIA" VARCHAR2(10 BYTE), 
	"VIA" VARCHAR2(50 BYTE) NOT NULL ENABLE, 
	"NUMERO" NUMBER(5,0) NOT NULL ENABLE, 
	"PISO" VARCHAR2(10 BYTE), 
	 CONSTRAINT "T_DIRECCIONES_PK" PRIMARY KEY ("ID_DIRECCION") ENABLE
   ) ;
/
 

REM TF2 T_TIPOCENTRAL

  CREATE TABLE "TF2"."T_TIPOCENTRAL" 
   (	"ID_TIPOCENTRAL" NUMBER, 
	"ENERGIAMIN" NUMBER, 
	"KGRADIOACTIVOS" NUMBER, 
	"EMISIONESCO2" NUMBER, 
	"NMOLINOS" NUMBER, 
	"MINPANELES" NUMBER, 
	 CONSTRAINT "T_TIPOCENTRAL_PK" PRIMARY KEY ("ID_TIPOCENTRAL") ENABLE
   ) ;
 
/


REM TF2 T_MODELO

  CREATE TABLE "TF2"."T_MODELO" 
   (	"ID_MODELO" NUMBER, 
	"MODELO" VARCHAR2(25 BYTE), 
	"FECHA_FABRICA" DATE, 
	"EMPRESAFAB" VARCHAR2(25 BYTE), 
	"CARACTERISTICAS" VARCHAR2(1000 BYTE), 
	 CONSTRAINT "T_MODELO_PK" PRIMARY KEY ("ID_MODELO") ENABLE
   ) ;

/


REM TF2 T_CLIENTES

  CREATE TABLE "TF2"."T_CLIENTES" 
   (	"NIF" VARCHAR2(12 BYTE) NOT NULL ENABLE, 
	"NOMBRE" VARCHAR2(100 BYTE) NOT NULL ENABLE, 
	"APELLIDOS" VARCHAR2(200 BYTE) NOT NULL ENABLE, 
	"CUENTA_CORRIENTE" NUMBER(25,0), 
	"ID_DIRECCION" NUMBER NOT NULL ENABLE, 
	"EMPRESA" NUMBER(1,0) DEFAULT 0 NOT NULL ENABLE, 
	"ID_NIF" NUMBER NOT NULL ENABLE, 
	 CONSTRAINT "T_CLIENTES_EMPRESA" CHECK ( "EMPRESA" IN ('0','1')) ENABLE, 
	 CONSTRAINT "T_CLIENTES_PK" PRIMARY KEY ("ID_NIF") ENABLE, 
	 CONSTRAINT "T_CLIENTES_T_DIRECCIONES_FK1" FOREIGN KEY ("ID_DIRECCION")
	  REFERENCES "TF2"."T_DIRECCIONES" ("ID_DIRECCION") ENABLE
   ) ;
 
/



REM TF2 T_CENTRALESDISTRIBUCION

  CREATE TABLE "TF2"."T_CENTRALESDISTRIBUCION" 
   (	"ID_CENTRALDIS" NUMBER DEFAULT 0, 
	"MAXIMODIS" NUMBER, 
	"ID_DIRECCION" NUMBER NOT NULL ENABLE, 
	"CONSUMO" NUMBER DEFAULT 0, 
	 CONSTRAINT "T_CENTRALESDISTRIBUCION_PK" PRIMARY KEY ("ID_CENTRALDIS") ENABLE, 
	 CONSTRAINT "T_CENTRALESDISTRIBUCION_FK" FOREIGN KEY ("ID_DIRECCION")
	  REFERENCES "TF2"."T_DIRECCIONES" ("ID_DIRECCION") ENABLE
   ) ;
 
/

REM TF2 T_CENTRALESPRODUCCION

  CREATE TABLE "TF2"."T_CENTRALESPRODUCCION" 
   (	"ID_CENTRALPROD" NUMBER, 
	"ID_DIRECCION" NUMBER NOT NULL ENABLE, 
	"CODIGO_CENTRAL_PROD" VARCHAR2(8 BYTE) NOT NULL ENABLE, 
	"HISTORICOENERGIA" NUMBER NOT NULL ENABLE, 
	"ENERGIAMAX" NUMBER NOT NULL ENABLE, 
	"ULTIMAINSPECCION" DATE, 
	"ID_TIPOCENTRAL" NUMBER NOT NULL ENABLE, 
	"ENERGIA_GENERADA" NUMBER, 
	 CONSTRAINT "T_CENTRALESPRODUCCION_PK" PRIMARY KEY ("ID_CENTRALPROD") ENABLE, 
	 CONSTRAINT "T_CENTRALESPRODUCCION_UK1" UNIQUE ("CODIGO_CENTRAL_PROD") ENABLE, 
	 CONSTRAINT "T_CENTRALESPRODUCCION_T_T_FK1" FOREIGN KEY ("ID_TIPOCENTRAL")
	  REFERENCES "TF2"."T_TIPOCENTRAL" ("ID_TIPOCENTRAL") ENABLE, 
	 CONSTRAINT "T_CENTRALESPRODUCCION_FK2" FOREIGN KEY ("ID_DIRECCION")
	  REFERENCES "TF2"."T_DIRECCIONES" ("ID_DIRECCION") ENABLE
   ) ;
 
/


REM TF2 T_LINEASCOMUNIC

  CREATE TABLE "TF2"."T_LINEASCOMUNIC" 
   (	"ID_LINEACOM" NUMBER, 
	"CAPACIDADMAX" NUMBER NOT NULL ENABLE, 
	"CONSUMOLINEA" NUMBER(10,3) DEFAULT 0 NOT NULL ENABLE, 
	 CONSTRAINT "T_LINEASCOMUNIC_PK" PRIMARY KEY ("ID_LINEACOM") ENABLE
   ) ;
 
/

REM TF2 T_PRODUC_DIS

  CREATE TABLE "TF2"."T_PRODUC_DIS" 
   (	"ID_CENTRALPROD" NUMBER NOT NULL ENABLE, 
	"ID_CENTRALDIS" NUMBER NOT NULL ENABLE, 
	"ID_LINEACOM" NUMBER NOT NULL ENABLE, 
	"ID_PRODUCT_DIS" NUMBER NOT NULL ENABLE, 
	 CONSTRAINT "T_PRODUC_DIS_PK" PRIMARY KEY ("ID_PRODUCT_DIS") ENABLE, 
	 CONSTRAINT "T_PRODUC_DIS_FK2" FOREIGN KEY ("ID_CENTRALPROD")
	  REFERENCES "TF2"."T_CENTRALESPRODUCCION" ("ID_CENTRALPROD") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "T_PRODUC_DIS_T_LINEASCOMU_FK1" FOREIGN KEY ("ID_LINEACOM")
	  REFERENCES "TF2"."T_LINEASCOMUNIC" ("ID_LINEACOM") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "T_PRODUC_DIS_FK3" FOREIGN KEY ("ID_CENTRALDIS")
	  REFERENCES "TF2"."T_CENTRALESDISTRIBUCION" ("ID_CENTRALDIS") ENABLE
   ) ;
 

/


REM TF2 T_CONTADOR

  CREATE TABLE "TF2"."T_CONTADOR" 
   (	"ID_CONTADOR" NUMBER, 
	"POTENCIA" NUMBER DEFAULT 2.5, 
	"LECTURATOT" NUMBER(10,3) DEFAULT 0 NOT NULL ENABLE, 
	"CONSUMOMEN" NUMBER(10,3) DEFAULT 0 NOT NULL ENABLE, 
	"CONSUMOTOT" NUMBER(10,3) DEFAULT 0 NOT NULL ENABLE, 
	"ID_MODELO" NUMBER NOT NULL ENABLE, 
	"FECHA_INSTALACION" DATE NOT NULL ENABLE, 
	"ID_DIRECCION" NUMBER NOT NULL ENABLE, 
	"DATA_ULTIMALECTURA" DATE, 
	"SERIALNUMBER" VARCHAR2(25 BYTE), 
	"CODCONTRATO" VARCHAR2(12 BYTE) NOT NULL ENABLE, 
	 CONSTRAINT "T_CONTADOR_POT" CHECK ( "POTENCIA" BETWEEN 0 AND 9999) ENABLE, 
	 CONSTRAINT "T_CONTADOR_LECTURA" CHECK ( "DATA_ULTIMALECTURA" >= "FECHA_INSTALACION") ENABLE, 
	 CONSTRAINT "T_CONTADOR_PK" PRIMARY KEY ("ID_CONTADOR") ENABLE, 
	 CONSTRAINT "T_CONTADOR_UK1" UNIQUE ("CODCONTRATO") ENABLE, 
	 CONSTRAINT "T_CONTADOR_UK2" UNIQUE ("SERIALNUMBER") ENABLE, 
	 CONSTRAINT "T_CONTADOR_T_DIRECCIONES_FK1" FOREIGN KEY ("ID_DIRECCION")
	  REFERENCES "TF2"."T_DIRECCIONES" ("ID_DIRECCION") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "T_CONTADOR_T_MODELO_FK1" FOREIGN KEY ("ID_MODELO")
	  REFERENCES "TF2"."T_MODELO" ("ID_MODELO") ENABLE
   ) ;
 
/



REM TF2 T_CON_CENTRALES

  CREATE TABLE "TF2"."T_CON_CENTRALES" 
   (	"ID_CONTADOR" NUMBER NOT NULL ENABLE, 
	"ID_CENTRALDIS" NUMBER NOT NULL ENABLE, 
	"ID_CON_CENTRALES" NUMBER NOT NULL ENABLE, 
	 CONSTRAINT "T_CON_CENTRALES_PK" PRIMARY KEY ("ID_CON_CENTRALES") ENABLE, 
	 CONSTRAINT "T_CON_CENTRALES_FK" FOREIGN KEY ("ID_CONTADOR")
	  REFERENCES "TF2"."T_CONTADOR" ("ID_CONTADOR") ON DELETE CASCADE ENABLE, 
	 CONSTRAINT "T_CON_CENTRALES_FK2" FOREIGN KEY ("ID_CENTRALDIS")
	  REFERENCES "TF2"."T_CENTRALESDISTRIBUCION" ("ID_CENTRALDIS") ENABLE
   ) ;
 
/



REM TF2 T_CLIENTECONTADOR

  CREATE TABLE "TF2"."T_CLIENTECONTADOR" 
   (	"ID_NIF" NUMBER NOT NULL ENABLE, 
	"ID_CONTADOR" NUMBER NOT NULL ENABLE, 
	"ID_CLIENTECONTADOR" NUMBER NOT NULL ENABLE, 
	 CONSTRAINT "T_CLIENTECONTADOR_PK" PRIMARY KEY ("ID_CLIENTECONTADOR") ENABLE, 
	 CONSTRAINT "T_CLIENTECONTADOR_T_CLIEN_FK1" FOREIGN KEY ("ID_NIF")
	  REFERENCES "TF2"."T_CLIENTES" ("ID_NIF") ENABLE, 
	 CONSTRAINT "T_CLIENTECONTADOR_FK2" FOREIGN KEY ("ID_CONTADOR")
	  REFERENCES "TF2"."T_CONTADOR" ("ID_CONTADOR") ENABLE
   ) ;
 


/


REM TF2 T_LECTURAS

  CREATE TABLE "TF2"."T_LECTURAS" 
   (	"ID_LECTURAS" NUMBER, 
	"ID_CONTADOR" NUMBER NOT NULL ENABLE, 
	"FECHALEC" DATE, 
	"TELEMATICA" NUMBER(1,0) DEFAULT 0 NOT NULL ENABLE, 
	"LECTURA" NUMBER(10,3) NOT NULL ENABLE, 
	 CONSTRAINT "T_LECTURAS_CON" CHECK ( "TELEMATICA" IN ('0', '1')) ENABLE, 
	 CONSTRAINT "T_LECTURAS_PK" PRIMARY KEY ("ID_LECTURAS") ENABLE, 
	 CONSTRAINT "T_LECTURAS_T_CONTADOR_FK1" FOREIGN KEY ("ID_CONTADOR")
	  REFERENCES "TF2"."T_CONTADOR" ("ID_CONTADOR") ENABLE
   ) ;

/

spool off;