
REM TF2 AMBCLIENTES

  CREATE OR REPLACE PACKAGE "TF2"."AMBCLIENTES" AS
/*********************************************************************************
PROCEDURE PR_ALTA_CONTADOR Realiza el alta de la tabla T_CLIENTES
Es obligatorio introducir los campos necesarios y que el cliente no exista.

Parametros de entrada:         p_nif              Necesario
                               p_nombre           Necesario
                               p_apellidos        Necesario
                               p_cuenta_corriente Opcional    
                               p_id_direccion     Necesario
                               p_empresa          Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CLIENTE (    p_nif              IN t_CLIENTES.NIF%TYPE,
                               p_nombre           IN T_CLIENTES.NOMBRE%TYPE,
                               p_apellidos        IN T_CLIENTES.APELLIDOS%TYPE,
                               p_cuenta_corriente IN T_CLIENTES.CUENTA_CORRIENTE%TYPE,    
                               p_id_direccion     IN T_CLIENTES.ID_DIRECCION%TYPE,
                               p_empresa          IN T_CLIENTES.EMPRESA%TYPE,                           
		               resultado            OUT VARCHAR2);
                               
/*************************************************************************
PROCEDURE PR_BAJA_CLIENTE Realiza la baja de un registro de la tabla T_CLIENTES

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_NIF    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CLIENTE ( p_id_NIF IN T_CLIENTES.ID_NIF%TYPE,
                                resultado       OUT VARCHAR2); 
                                
/*************************************************************************
PROCEDURE PR_MODI_CLIENTE Modifica un registro de la tabla T_CLIENTES

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_NIF           Necesario
                               p_nif              Opcional
                               p_nombre           Opcional
                               p_apellidos        Opcional
                               p_cuenta_corriente Opcional    
                               p_id_direccion     Opcional
                               p_empresa          Opcional
	Modifica:	       resultado       
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CLIENTE(     p_id_NIF           IN T_CLIENTES.ID_NIF%TYPE,
                               p_nif              IN T_CLIENTES.NIF%TYPE,
                               p_nombre           IN T_CLIENTES.NOMBRE%TYPE,
                               p_apellidos        IN T_CLIENTES.APELLIDOS%TYPE,
                               p_cuenta_corriente IN T_CLIENTES.CUENTA_CORRIENTE%TYPE,    
                               p_id_direccion     IN T_CLIENTES.ID_DIRECCION%TYPE,
                               p_empresa          IN T_CLIENTES.EMPRESA%TYPE,                           
		               resultado            OUT VARCHAR2);                                
                              
/*********************************************************************************
PROCEDURE PR_ALTA_CLIENTECONTADOR Realiza el alta de la tabla T_CLIENTECONTADOR
Es obligatorio introducir los campos necesarios y qu la asociacion no exista.

Parametros de entrada:         p_nif              Necesario
                               p_id_direccion     Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CLIENTECONTADOR (    p_id_nif             IN T_CLIENTECONTADOR.ID_NIF%TYPE,
                                       p_id_contador        IN T_CLIENTECONTADOR.ID_CONTADOR%TYPE,
                                       resultado            OUT VARCHAR2);                            


/*************************************************************************
PROCEDURE PR_BAJA_CLIENTECONTADOR Realiza la baja de un registro de la tabla T_CLIENTECONTADOR

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:          p_id_clientecontador    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CLIENTECONTADOR ( p_id_clientecontador IN T_CLIENTECONTADOR.ID_CLIENTECONTADOR%TYPE,
                                    resultado       OUT VARCHAR2);   
/*************************************************************************
PROCEDURE PR_MODI_CLIENTECONTADOR Modifica un registro de la tabla T_CLIENTECONTADOR

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_clientecontador  Necesario
                               p_nif                 Opcional
                               p_id_direccion        Opcional
	Modifica:	       resultado       
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CLIENTECONTADOR(  p_id_clientecontador IN T_CLIENTECONTADOR.ID_CLIENTECONTADOR%TYPE,  
                                    p_id_nif             IN T_CLIENTECONTADOR.ID_NIF%TYPE,
                                    p_id_contador        IN T_CLIENTECONTADOR.ID_CONTADOR%TYPE,
                                    resultado            OUT VARCHAR2);
END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."AMBCLIENTES" AS
/*********************************************************************************
PROCEDURE PR_ALTA_CONTADOR Realiza el alta de la tabla T_CLIENTES
Es obligatorio introducir los campos necesarios y que el cliente no exista.

Parametros de entrada:         p_nif              Necesario
                               p_nombre           Necesario
                               p_apellidos        Necesario
                               p_cuenta_corriente Opcional    
                               p_id_direccion     Necesario
                               p_empresa          Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CLIENTE (    p_nif              IN T_CLIENTES.NIF%TYPE,
                               p_nombre           IN T_CLIENTES.NOMBRE%TYPE,
                               p_apellidos        IN T_CLIENTES.APELLIDOS%TYPE,
                               p_cuenta_corriente IN T_CLIENTES.CUENTA_CORRIENTE%TYPE,    
                               p_id_direccion     IN T_CLIENTES.ID_DIRECCION%TYPE,
                               p_empresa          IN T_CLIENTES.EMPRESA%TYPE,                           
		               resultado            OUT VARCHAR2)
IS
 
   E_CAMPO_VACIO         EXCEPTION;
   E_CLIENTE_EXISTE      EXCEPTION;
   E_VALORP_NOEXISTE     EXCEPTION;
   
   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

BEGIN
     	p_entrada:= 'NIF: '||p_nif||',NOMBRE: '||p_nombre||', APELLIDOS:'||p_apellidos||',CUENTA CORRIENTE:'||p_cuenta_corriente||',ID DIRECCION: '||p_id_direccion||', EMPRESA: '||p_empresa;

     	/*Verifica que todos los campos obligatorios tengan valor ( id_modelo,fecha_inst,id_direccion,serialnumber,codcontrato*/

    	IF ((TRIM(p_nif)IS NULL)or(TRIM(p_nombre)IS NULL)or(TRIM(p_apellidos)IS NULL)or(TRIM(p_id_direccion)IS NULL)or(TRIM(p_empresa)IS NULL)) 
          THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	
     /*Verifica que no exista el contador */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CLIENTES
       	       	WHERE (NIF=p_nif)
          	AND ROWNUM  = 1;
          	RAISE E_CLIENTE_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;

     /*Verifica que exista la direccion */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
          END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/
      

      INSERT INTO T_CLIENTES (NIF,NOMBRE,APELLIDOS,CUENTA_CORRIENTE,ID_DIRECCION,EMPRESA)
           VALUES (p_nif,p_nombre,p_apellidos,p_cuenta_corriente ,p_id_direccion, p_empresa);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTE',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista el cliente rellenamos el LOG*/    
    WHEN E_CLIENTE_EXISTE THEN
      resultado := 'KO: El cliente ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTE',p_entrada,' ', resultado);
      COMMIT;
     /*Excepcion en caso que no exista la direccion rellenamos el LOG*/    
      WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: La direccion no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTE',p_entrada,' ', resultado);
      COMMIT;      
      
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTE',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTE',p_entrada,' ', resultado);
      COMMIT;

END PR_ALTA_CLIENTE;

/*************************************************************************
PROCEDURE PR_BAJA_CLIENTE Realiza la baja de un registro de la tabla T_CLIENTES

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_NIF    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CLIENTE ( p_id_NIF IN T_CLIENTES.ID_NIF%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_NIF: '||p_id_NIF;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_NIF)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CLIENTES
        WHERE ID_NIF = p_id_nif
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_CLIENTES
   	WHERE ID_NIF = p_id_nif;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTE',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: El cliente a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTE',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_PRODUC_DIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTE',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTE',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_CLIENTE;
  
  
/*************************************************************************
PROCEDURE PR_MODI_CLIENTE Modifica un registro de la tabla T_CLIENTES

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_NIF           Necesario
                               p_nif              Opcional
                               p_nombre           Opcional
                               p_apellidos        Opcional
                               p_cuenta_corriente Opcional    
                               p_id_direccion     Opcional
                               p_empresa          Opcional
	Modifica:	       resultado          
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CLIENTE   (  p_id_NIF           IN T_CLIENTES.ID_NIF%TYPE,
                               p_nif              IN T_CLIENTES.NIF%TYPE,
                               p_nombre           IN T_CLIENTES.NOMBRE%TYPE,
                               p_apellidos        IN T_CLIENTES.APELLIDOS%TYPE,
                               p_cuenta_corriente IN T_CLIENTES.CUENTA_CORRIENTE%TYPE,    
                               p_id_direccion     IN T_CLIENTES.ID_DIRECCION%TYPE,
                               p_empresa          IN T_CLIENTES.EMPRESA%TYPE,                           
		               resultado            OUT VARCHAR2)

IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
   p_entrada:= 'ID NIF: '||p_id_nif||', NIF: '||p_nif||',NOMBRE: '||p_nombre||', APELLIDOS:'||p_apellidos||',CUENTA CORRIENTE:'||p_cuenta_corriente||',ID DIRECCION: '||p_id_direccion||', EMPRESA: '||p_empresa;
   
    
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_NIF)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que el cliente exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CLIENTES
        WHERE ID_NIF=p_id_nif
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      
    /*Verifica que la direccion exista*/
              BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
          END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
      
     UPDATE T_CLIENTES
                             
        SET NIF     =nvl(p_nif,NIF),
            NOMBRE  =nvl( p_nombre,NOMBRE),
            APELLIDOS  =nvl(p_apellidos,APELLIDOS),
            CUENTA_CORRIENTE  =nvl(p_cuenta_corriente,CUENTA_CORRIENTE),
            ID_DIRECCION  =nvl(p_id_direccion,ID_DIRECCION),
            EMPRESA  =nvl(p_empresa,EMPRESA)
                                  
     WHERE  ID_NIF=p_id_NIF;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTE',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: El cliente a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTE',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_VALORP_NOEXISTE THEN
        resultado := 'KO: LA direccion no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTE',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_NIF no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTE',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTE',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_CLIENTE; 

  
  
                                
/*********************************************************************************
PROCEDURE PR_ALTA_CLIENTECONTADOR Realiza el alta de la tabla T_CLIENTECONTADOR
Es obligatorio introducir los campos necesarios y qu la asociacion no exista.

Parametros de entrada:         p_nif              Necesario
                               p_id_direccion     Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CLIENTECONTADOR (    p_id_nif              IN T_CLIENTECONTADOR.ID_NIF%TYPE,
                                       p_id_contador      IN T_CLIENTECONTADOR.ID_CONTADOR%TYPE,
                                       resultado            OUT VARCHAR2)
IS
 
   E_CAMPO_VACIO          EXCEPTION;
   E_CLIENTE_EXISTE      EXCEPTION;
   E_VALORP_NOEXISTE     EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   temp         NUMBER;
   valor        NUMBER;

BEGIN
     	p_entrada:= 'ID NIF: '||p_id_nif||',ID CONTADOR: '||p_id_contador;

     	/*Verifica que todos los campos obligatorios tengan valor ( id_modelo,fecha_inst,id_direccion,serialnumber,codcontrato*/

    	IF ((TRIM(p_id_nif)IS NULL)or(TRIM(p_id_contador)IS NULL)) 
          THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	
     /*Verifica que no exista la asociacion */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CLIENTECONTADOR
       	       	WHERE (ID_NIF=p_id_nif)
          	AND ROWNUM  = 1;
          	RAISE E_CLIENTE_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
       /*Verifica que exista el contador y el cliente */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CLIENTES
        WHERE (ID_NIF=p_id_nif)
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_CONTADOR=p_id_contador
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;
           	
      END; 
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/
      
/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 7 (Consumo medio de los clientes)*/

       SELECT COUNT(*) INTO temp 
       FROM T_ESTADISTICA7;
       
        IF (temp) = 0 then       
          INSERT INTO T_ESTADISTICA7(ID_E7,CONTA_CONSUMOMEDIO)
          VALUES (1,0);
        END if;

select sum(consumotot) into valor
from T_contador;


SELECT COUNT(distinct T_CLIENTECONTADOR.id_NIF) into temp
FROM T_CLIENTES,T_CLIENTECONTADOR;

if valor=0 or temp=0 then 
valor:=0;
else
valor:=valor/temp;
end if; 

  UPDATE T_ESTADISTICA7
     SET CONTA_CONSUMOMEDIO =nvl(valor,CONTA_CONSUMOMEDIO)
     WHERE  ID_E7=1;
     
     
 COMMIT;
 
 --REALIZAMOS EL ALTA
      

      INSERT INTO T_CLIENTECONTADOR (ID_NIF,ID_CONTADOR)
           VALUES (p_id_nif,p_id_contador);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista la asociacion rellenamos el LOG*/    
    WHEN E_CLIENTE_EXISTE THEN
      resultado := 'KO: La asociacion ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
            /*Excepcion en caso que no  exista algun parametro y rellenamos el LOG*/    
    WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: La asociacion ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;                                       
                                       
                                       
END PR_ALTA_CLIENTECONTADOR;

/*************************************************************************
PROCEDURE PR_BAJA_CLIENTECONTADOR Realiza la baja de un registro de la tabla T_CLIENTECONTADOR

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:          p_id_clientecontador    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El cliente no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CLIENTECONTADOR ( p_id_clientecontador IN T_CLIENTECONTADOR.ID_CLIENTECONTADOR%TYPE,
                                    resultado       OUT VARCHAR2)   

IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   temp         NUMBER;
   valor        NUMBER;


   BEGIN

      p_entrada := 'ID_CLIENTECONTADOR: '||p_id_clientecontador;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM( p_id_clientecontador)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CLIENTECONTADOR
        WHERE ID_CLIENTECONTADOR =  p_id_clientecontador
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/
      
/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 7 (Consumo medio de los clientes)*/

       SELECT COUNT(*) INTO temp 
       FROM T_ESTADISTICA7;
       
        IF (temp) = 0 then       
          INSERT INTO T_ESTADISTICA7(ID_E7,CONTA_CONSUMOMEDIO)
          VALUES (1,0);
        END if;

select sum(consumotot) into valor
from T_contador;


SELECT COUNt(distinct T_CLIENTECONTADOR.id_NIF) into temp
FROM T_CLIENTES,T_CLIENTECONTADOR;
 
  UPDATE T_ESTADISTICA7
     SET CONTA_CONSUMOMEDIO =nvl(valor/temp,CONTA_CONSUMOMEDIO)
     WHERE  ID_E7=1;
     
     
 COMMIT;

--REALIZAMOS EL BORRADO

	DELETE FROM T_CLIENTECONTADOR
   	WHERE ID_CLIENTECONTADOR = id_clientecontador;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La asociacion a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTECONTADOR',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_PRODUC_DIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTECONTADOR',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CLIENTECONTADOR',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_CLIENTECONTADOR;                            
 
/*************************************************************************
PROCEDURE PR_MODI_CLIENTECONTADOR Modifica un registro de la tabla T_CLIENTECONTADOR

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_clientecontador  Necesario
                               p_nif                 Opcional
                               p_id_direccion        Opcional
	Modifica:	       resultado       
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CLIENTECONTADOR(  p_id_clientecontador IN T_CLIENTECONTADOR.ID_CLIENTECONTADOR%TYPE,  
                                    p_id_nif             IN T_CLIENTECONTADOR.ID_NIF%TYPE,
                                    p_id_contador        IN T_CLIENTECONTADOR.ID_CONTADOR%TYPE,
                                    resultado            OUT VARCHAR2)

IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
    p_entrada:= 'ID CLIENTECONTADOR: '||p_id_clientecontador||', ID NIF: '||p_id_nif||',ID CONTADOR: '||p_id_contador;
    
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_clientecontador)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la asociacion exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CLIENTECONTADOR
        WHERE ID_CLIENTECONTADOR=p_id_clientecontador
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      
             /*Verifica que exista el contador y el cliente */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CLIENTES
        WHERE (ID_NIF=p_id_nif)
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_CONTADOR=p_id_contador
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;
           	
      END; 
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
           
     UPDATE T_CLIENTECONTADOR
                             
        SET ID_NIF  =nvl(p_id_nif,ID_NIF),
            ID_CONTADOR  =nvl(p_id_contador,ID_CONTADOR)
                                  
     WHERE  ID_CLIENTECONTADOR=p_id_clientecontador;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La asociacion a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_VALORP_NOEXISTE THEN
        resultado := 'KO: El cliente o contador no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CLIENTECONTADOR no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CLIENTECONTADOR',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_CLIENTECONTADOR; 

END "AMBCLIENTES";
/
 
REM TF2 AMBLINEAS

  CREATE OR REPLACE PACKAGE "TF2"."AMBLINEAS" AS
/*********************************************************************************
PROCEDURE PR_ALTA_LINEAS Realiza el alta de la tabla T_LINEASCOMUNIC
Es obligatorio introducir los campos necesario y que la linea no exista.

Parametros de entrada:         p_capacidadmax      Necesario
                            Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_LINEAS  (p_capacidadmax  IN T_LINEASCOMUNIC.CAPACIDADMAX%TYPE,
                                  resultado            OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_BAJA_LINEAS Realiza la baja de un registro de la tabla T_LINEASCOMUNIC

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_lineacom   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_LINEAS ( p_id_lineacom IN T_LINEASCOMUNIC.ID_LINEACOM%TYPE,
                                resultado       OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_MODI_LINEAS Modifica un registro de la tabla T_LINEAS

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_linea         Necesario
                               p_capacidadmax      opcional
                               p_consumolinea      opcional
	Modifica:	       resultado      
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_LINEAS(  p_id_lineacom     IN T_LINEASCOMUNIC.ID_LINEACOM%TYPE, 
                           p_capacidadmax  IN T_LINEASCOMUNIC.CAPACIDADMAX%TYPE,
                           p_consumolinea  IN T_LINEASCOMUNIC.CONSUMOLINEA%TYPE, 
          	           resultado            OUT VARCHAR2);

END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."AMBLINEAS" AS
/*********************************************************************************
PROCEDURE PR_ALTA_LINEAS Realiza el alta de la tabla T_LINEASCOMUNIC
Es obligatorio introducir los campos necesario y que la linea no exista.

Parametros de entrada:         p_capacidadmax      Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_LINEAS (p_capacidadmax  IN T_LINEASCOMUNIC.CAPACIDADMAX%TYPE, 
          	          resultado            OUT VARCHAR2)
IS
   E_CAMPO_VACIO        EXCEPTION;
   E_LINEA_EXISTE       EXCEPTION;
 
   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   valor         NUMBER;
   ano           number;
   tempo         number;
   
BEGIN
     	p_entrada:= 'CAPACIDAD MAXIMAS: '||p_capacidadmax;

     	/*Verifica que todos los campos obligatorios tengan valor ( id_modelo,fecha_inst,id_direccion,serialnumber,codcontrato*/

    	IF ((TRIM(p_capacidadmax)IS NULL)) 
          THEN RAISE E_CAMPO_VACIO;
      	END IF;
     	

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/

      INSERT INTO T_LINEASCOMUNIC (CAPACIDADMAX,CONSUMOLINEA)
           VALUES (p_capacidadmax,0);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LINEAS',p_entrada,' ', resultado);
     
      
      /* AiÃ‚Â±adimos la linea a la estadistica 2 */
      
     SELECT max(ID_LINEACOM) into valor
     from T_LINEASCOMUNIC
     WHERE (CAPACIDADMAX=p_capacidadmax and CONSUMOLINEA=0);
        
     
     select extract(year from sysdate)  into ano
     from dual;
  
     INSERT INTO T_ESTADISTICA2 (ANO1,ID_LINEACOM,CONSUMOMEDIO,CONSUMOTOT)
     VALUES (ano,valor,0,0);             
     
     /* La primera vez aiÃ‚Â±adimos la linea a la estadistica 3 y 4 */
     
       SELECT COUNT(*) INTO tempo 
       FROM T_ESTADISTICA3;
       
        IF (tempo) = 0 then       
          INSERT INTO T_ESTADISTICA3(ID_E3,ID_LINEACOM,TOPCONSUMO)
          VALUES (1,valor,0);
        END if;
      
      SELECT COUNT(*) INTO tempo 
       FROM T_ESTADISTICA4;
              
        IF (tempo) = 0 then       
          INSERT INTO T_ESTADISTICA4(ID_E4,ano2,total_lineas,lineas50con,porcentaje)
          VALUES (1,ano,1,0,0);
        Else
          update  T_ESTADISTICA4
          SET TOTAL_LINEAS =nvl(TOTAL_LINEAS+1,TOTAL_LINEAS) 
          WHERE  ano=ano2;
          
        END if;   
          
     
     
        
      
      
      Commit;
     
  EXCEPTION

    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LINEAS',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LINEAS',p_entrada,' ', resultado);
      COMMIT;     
      
  END PR_ALTA_LINEAS;
  
  
/*************************************************************************
PROCEDURE PR_BAJA_LINEAS Realiza la baja de un registro de la tabla T_LINEASCOMUNIC

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_lineacom   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_LINEAS ( p_id_lineacom IN T_LINEASCOMUNIC.ID_LINEACOM%TYPE,
                                resultado       OUT VARCHAR2)  
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   ano           NUMBER;
   valor         NUMBER;
   p_id_lin      NUMBER;

   BEGIN

      p_entrada := 'ID_LINEACOM: '||p_id_lineacom;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_lineacom)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_LINEASCOMUNIC
        WHERE ID_LINEACOM = p_id_lineacom
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_LINEASCOMUNIC
   	WHERE ID_LINEACOM = p_id_lineacom;
      /*ACTUAALIZAMOS ESTADISTICA 4 */   
          select extract(year from sysdate)  into ano
          from dual;
          update  T_ESTADISTICA4
          SET TOTAL_LINEAS =nvl(TOTAL_LINEAS-1,TOTAL_LINEAS) 
          WHERE  ano=ano2;
      /*ACTUAALIZAMOS ESTADISTICA 2 */   
         delete from  T_ESTADISTICA2
         WHERE  p_id_lineacom=ID_LINEACOM;
        /*ACTUAALIZAMOS ESTADISTICA 3 */   
         delete from  T_ESTADISTICA3
         WHERE  p_id_lineacom=ID_LINEACOM;   
         
         /*AQUI ACTUALIZAMOS TABLA DE ESTADISTICA 3 (TOP LINEAS)*/      

SELECT max(C) into valor
from (select SUM(CONSUMOTOT) as C , ID_LINEACOM from T_ESTADISTICA2 group by ID_LINEACOM);

Select L into p_id_lin from 
(select * from (select SUM(CONSUMOTOT) as C, ID_LINEACOM as L from T_ESTADISTICA2 group by ID_LINEACOM  order by c desc)
where rownum=1);


  UPDATE T_ESTADISTICA3
        SET ID_LINEACOM =nvl((p_id_lin),ID_LINEACOM),
            TOPCONSUMO=nvl(valor , TOPCONSUMO)
     WHERE  ID_E3= 1;
         
         
     
     
      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LINEAS COMUNICACION',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La linea a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LINEAS COMUNICA',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_LINEACOM no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LINEAS COMUNICA',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LINEAS COMUNICA',p_entrada,' ', resultado);

        COMMIT; 

  END PR_BAJA_LINEAS;

/*************************************************************************
PROCEDURE PR_MODI_LINEAS Modifica un registro de la tabla T_LINEAS

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_linea         Necesario
                               p_capacidadmax      opcional
                               p_consumolinea      opcional
	Modifica:	       resultado      
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La linea no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_LINEAS(  p_id_lineacom     IN T_LINEASCOMUNIC.ID_LINEACOM%TYPE, 
                           p_capacidadmax  IN T_LINEASCOMUNIC.CAPACIDADMAX%TYPE,
                           p_consumolinea  IN T_LINEASCOMUNIC.CONSUMOLINEA%TYPE, 
          	           resultado            OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
    
    p_entrada:= 'ID LINEACOM: '||p_id_lineacom||'CAPACIDAD MAXIMAS: '||p_capacidadmax||', CONSUMO LINEA:'||p_consumolinea;
     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_lineacom)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_LINEASCOMUNIC
        WHERE ID_LINEACOM=p_id_lineacom
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
           
     UPDATE T_LINEASCOMUNIC
        SET CAPACIDADMAX  =nvl(p_capacidadmax,CAPACIDADMAX),
            CONSUMOLINEA  =nvl(p_consumolinea,CONSUMOLINEA)
                                  
     WHERE  ID_LINEACOM=p_id_lineacom;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LINEAS DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La linea a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LINEAS DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_LINEACOM no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LINEAS DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LINEAS DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_LINEAS;  



END "AMBLINEAS";
/
 
REM TF2 AMBLECTURAS

  CREATE OR REPLACE PACKAGE "TF2"."AMBLECTURAS" AS
/*********************************************************************************
PROCEDURE PR_ALTA_LECTURA Realiza el alta de la tabla T_LECTURAS
Es obligatorio introducir los campos necesario y que el contador no exista.

Parametros de entrada:         p_id_contador      Necesario
                               p_fechalec         Necesario
                               p_telematica       Necesario    
                               p_lectura          Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_LECTURA (p_id_contador  IN T_LECTURAS.ID_CONTADOR%TYPE,
                           p_fechalec     IN T_LECTURAS.FECHALEC%TYPE, 
                           p_telematica   IN T_LECTURAS.TELEMATICA%TYPE,
                           p_lectura      IN T_LECTURAS.LECTURA%TYPE,    
		           resultado            OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_BAJA_T_LECTURA Realiza la baja de un registro de la tabla T_LECTURA

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_lectura   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_LECTURA ( p_id_lecturas IN T_LECTURAS.ID_LECTURAS%TYPE,
                                resultado       OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_MODI_LECTURA Modifica un registro de la tabla T_LECTURAS

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_lecturas      Necesario
                               p_id_contador      Opcional
                               p_fechalec         Opcional
                               p_telematica       Opcional
                               p_lectura          Opcional
	Modifica:	       resultado       
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_LECTURAS(  p_id_lecturas  IN T_LECTURAS.ID_LECTURAS%TYPE,
                             p_id_contador  IN T_LECTURAS.ID_CONTADOR%TYPE,
                             p_fechalec     IN T_LECTURAS.FECHALEC%TYPE, 
                             p_telematica   IN T_LECTURAS.TELEMATICA%TYPE,
                             p_lectura      IN T_LECTURAS.LECTURA%TYPE,    
		             resultado            OUT VARCHAR2);
END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."AMBLECTURAS" AS
/*********************************************************************************
PROCEDURE PR_ALTA_LECTURA Realiza el alta de la tabla T_LECTURAS
Es obligatorio introducir los campos necesario y que el contador no exista.

Parametros de entrada:         p_id_contador      Necesario
                               p_fechalec         Necesario
                               p_telematica       Necesario    
                               p_lectura          Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_LECTURA (p_id_contador  IN T_LECTURAS.ID_CONTADOR%TYPE,
                           p_fechalec     IN T_LECTURAS.FECHALEC%TYPE, 
                           p_telematica   IN T_LECTURAS.TELEMATICA%TYPE,
                           p_lectura      IN T_LECTURAS.LECTURA%TYPE,    
		           resultado            OUT VARCHAR2)

-- cursor que guarda las lineas que afecta la lectura
IS
  CURSOR LINEAS_AF IS
SELECT T_PRODUC_DIS.ID_LINEACOM as L_AFECTADAS
 from  T_CON_CENTRALES,T_PRODUC_DIS
 where (p_id_contador=T_CON_CENTRALES.ID_CONTADOR)and(T_CON_CENTRALES.ID_CENTRALDIS=T_PRODUC_DIS.ID_CENTRALDIS);

-- cursor que guarda las centrales de produccion existentes
 cursor central_af is  
 select ID_CENTRALPROD as C_AFECTADAS
 from T_CENTRALESPRODUCCION;
 
   E_CAMPO_VACIO          EXCEPTION;
   E_LECTURA_EXISTE       EXCEPTION;
   E_NO_CONECTADO         EXCEPTION;
   
   VALOR            NUMBER(10,3):=0;
   existe           VARCHAR2(1);
   p_entrada        VARCHAR2(1000);
   err_num          NUMBER;
   err_msg          VARCHAR2(100);
   p_id_centralprod NUMBER;
   ano              NUMBER;
   p_id_lin         NUMBER;
   TOTEnergia       NUMBER;
   temp             NUMBER;
   temp2            number;
   consumo_total    NUMBER;
   tempdate         DATE;
   X                NUMBER;
  

 
 

  
BEGIN
     	p_entrada:= 'ID CONTADOR: '||p_id_contador||', FECHA LECTURA:'||p_fechalec||', TELEMATICA:'||p_telematica||',LECTURA:'||p_lectura;

     	/*Verifica que todos los campos obligatorios tengan valor ( id_modelo,fecha_inst,id_direccion,serialnumber,codcontrato*/

    	IF ((TRIM(p_id_contador)IS NULL)or(TRIM(p_fechalec)IS NULL)or(TRIM(p_telematica)IS NULL)or(TRIM(p_lectura)IS NULL)) 
          THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	
     /*Verifica que no exista el contador */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_LECTURAS
       	       	WHERE ((ID_CONTADOR=p_id_contador)AND(FECHALEC=p_fechalec)AND(LECTURA=p_lectura))
          	AND ROWNUM  = 1;
          	RAISE E_LECTURA_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;

     /*Verifica que el contador tenga conexion */
     BEGIN
	       	SELECT id_contador INTO existe
               	FROM T_CON_CENTRALES,T_PRODUC_DIS
       	       	WHERE ((T_CON_CENTRALES.ID_CONTADOR=p_id_contador)AND(T_CON_CENTRALES.ID_CENTRALDIS=T_PRODUC_DIS.ID_CENTRALDIS))
          	AND ROWNUM  = 1;
          	EXCEPTION
                WHEN NO_DATA_FOUND THEN
                RAISE E_NO_CONECTADO;
      END;
                
   

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla  y rellenamos el LOG*/

      INSERT INTO T_LECTURAS (ID_CONTADOR,FECHALEC,TELEMATICA,LECTURA)
           VALUES (p_id_contador,p_fechalec,p_telematica ,p_lectura);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LECTURA',p_entrada,' ', resultado);
      

--INSERTAMOS EL VALOR DE LA LECTURA EN CONSUMO DEL CONTADOR
    SELECT CONSUMOTOT into valor
    FROM T_CONTADOR
    WHERE ID_CONTADOR=p_id_contador;
    valor:=p_lectura-valor;
    
    /*comprobamos que la lectura sea del mismo mes*/
    select DATA_ULTIMALECTURA into tempdate 
    from T_CONTADOR
    where ID_CONTADOR=p_id_contador;
  
    
 if extract(month from p_fechalec)=extract(month from tempdate) then 
        UPDATE T_CONTADOR
        SET CONSUMOMEN =nvl(VALOR+CONSUMOMEN,CONSUMOMEN),           
                DATA_ULTIMALECTURA =nvl(p_fechalec,DATA_ULTIMALECTURA),           
                CONSUMOTOT =nvl(p_lectura,CONSUMOTOT),
                LECTURATOT=CONSUMOTOT
        WHERE  ID_CONTADOR=p_id_contador;
 else
        UPDATE T_CONTADOR
        SET CONSUMOMEN =nvl(VALOR,CONSUMOMEN),           
                DATA_ULTIMALECTURA =nvl(p_fechalec,DATA_ULTIMALECTURA),           
                CONSUMOTOT =nvl(p_lectura,CONSUMOTOT),
                LECTURATOT=CONSUMOTOT
        WHERE  ID_CONTADOR=p_id_contador;
 
 end if;     
 
--SELECCIONAMOS EN ANO A ACTUALIZAR

      select extract(year from p_fechalec)  into ano  from dual;   
 
 --COMPROBAMOS SI ES NECESARIO ACTUALIZA ESTADISTICAS QUE TRABJAN CON EL ANO (2, 4 y5)
 
 select max(ano2) into temp from T_ESTADISTICA4;
 
 if temp<ano then 
 
 select total_lineas into temp2 from T_ESTADISTICA4 where temp=ano2;
 
 insert into T_ESTADISTICA4(ano2,TOTAL_LINEAS,LINEAS50CON,PORCENTAJE)
 VALUES (ano,temp2,0,0);
 
          INSERT INTO T_ESTADISTICA5(ANO3,CENTRALESMIN30)
          VALUES (ano,0);

   
   FOR REG1 IN CENTRAL_AF LOOP
   
  insert into T_ESTADISTICA2(ano1,ID_LINEACOM,CONSUMOMEDIO,CONSUMOTOT)
  VALUES (ano,REG1.C_AFECTADAS,0,0);
   
  END LOOP; 


end if; 


 
 
/*AQUI ACTUALIZAMOS TABLA DE ESTADISTICA 1 (consumo de contadores que depende de la central)*/
 
 SELECT DISTINCT T_PRODUC_DIS.ID_CENTRALPROD into p_id_centralprod
 from T_CONTADOR,T_CON_CENTRALES,T_CENTRALESDISTRIBUCION,T_PRODUC_DIS
 where (p_id_contador=T_CON_CENTRALES.ID_CONTADOR)and (T_CON_CENTRALES.ID_CENTRALDIS=T_CENTRALESDISTRIBUCION.ID_CENTRALDIS) and
 (T_CENTRALESDISTRIBUCION.ID_CENTRALDIS=T_PRODUC_DIS.ID_CENTRALDIS); 
    
     
     UPDATE T_ESTADISTICA1
        SET CONSUM_TOTAL =nvl((CONSUM_TOTAL+valor),CONSUM_TOTAL)             
     WHERE  ID_CENTRALPROD=p_id_centralprod;

/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 5 (%de lineas que no superan el 30%energia)*/ 
      UPDATE T_ESTADISTICA5
     SET CENTRALESMIN30 =nvl(( 0 ),CENTRALESMIN30)             
     WHERE  ano=ano3;

 
   FOR REG1 IN CENTRAL_AF LOOP
 
   temp:=0;
   consumo_total:=0;
   
 SELECT ENERGIA_GENERADA into consumo_total
 from T_CENTRALESPRODUCCION
 where REG1.C_AFECTADAS=id_centralprod;

 SELECT ENERGIAMAX into temp
 from T_CENTRALESPRODUCCION
 where REG1.C_AFECTADAS=id_centralprod;
 
 
if  CONSUMO_TOTAL < (12* temp *0.30)then 
     UPDATE T_ESTADISTICA5
     SET CENTRALESMIN30 =nvl(( CENTRALESMIN30 +1 ),CENTRALESMIN30)             
     WHERE  ano=ano3; 
end if;
  END LOOP;   



/*AQUI ACTUALIZAMOS TABLA DE ESTADISTICA 2 (consumo soportados por las lineas)*/ 
  

 
  FOR REG1 IN LINEAS_AF LOOP

      UPDATE T_ESTADISTICA2
        SET CONSUMOTOT =nvl((CONSUMOTOT+valor),CONSUMOTOT)             
     WHERE  ID_LINEACOM=REG1.L_AFECTADAS and ANO1=ano;
    
    select avg(CONSUMOTOT) into valor
     from T_ESTADISTICA2
     where ANO1=ano;
    
    UPDATE T_ESTADISTICA2
     SET CONSUMOMEDIO =nvl((valor),CONSUMOMEDIO)             
     WHERE  ID_LINEACOM=REG1.L_AFECTADAS and ANO1=ano;
    
  END LOOP;
 
/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 4 (%de lineas que superan el 50%energia)*/

SELECT SUM(CONSUMOTOT) into TOTenergia
from t_estadistica2
where ano1=ano;
 
SELECT count(ano1) into temp
from t_estadistica2
where ano1=ano and (consumotot)>(TOTenergia/2);

SELECT TOTAL_LINEAS into temp2
from t_estadistica4
where ano2=ano;

  
  UPDATE T_ESTADISTICA4
     SET LINEAS50CON =nvl(temp,LINEAS50CON),
         PORCENTAJE=nvl( (LINEAS50CON * 100/temp2 )  ,PORCENTAJE)
     WHERE  ano=ano2;
     COMMIT;
    UPDATE T_ESTADISTICA4
     SET LINEAS50CON =nvl(temp,LINEAS50CON),
         PORCENTAJE=nvl( (temp * 100/temp2 )  ,PORCENTAJE)
     WHERE  ano=ano2;
     COMMIT;   
     
     
/*AQUI ACTUALIZAMOS TABLA DE ESTADISTICA 3 (TOP LINEAS)*/      

SELECT max(C) into valor
from (select SUM(CONSUMOTOT) as C , ID_LINEACOM from T_ESTADISTICA2 group by ID_LINEACOM);

Select L into p_id_lin from 
(select * from (select SUM(CONSUMOTOT) as C, ID_LINEACOM as L from T_ESTADISTICA2 group by ID_LINEACOM  order by c desc)
where rownum=1);


  UPDATE T_ESTADISTICA3
        SET ID_LINEACOM =nvl((p_id_lin),ID_LINEACOM),
            TOPCONSUMO=nvl(valor , TOPCONSUMO);





/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 6 (Top 10 consumo contadores)*/

Delete From T_ESTADISTICA6 Where rownum <11; 


insert into T_ESTADISTICA6(CODCONTA, LECTURA)
SELECT ID_CONTADOR, CONSUMOTOT   FROM T_CONTADOR 
where rownum <11
order by 2 desc;
 
 
/*AQUI ACTUALIZAMOS TABLA ESTADISTICA 7 (Consumo medio de los clientes)*/

       SELECT COUNT(*) INTO temp 
       FROM T_ESTADISTICA7;
       
        IF (temp) = 0 then       
          INSERT INTO T_ESTADISTICA7(ID_E7,CONTA_CONSUMOMEDIO)
          VALUES (1,0);
        END if;

select sum(consumotot) into valor
from T_contador;


SELECT COUNt(distinct T_CLIENTECONTADOR.id_NIF) into temp
FROM T_CLIENTES,T_CLIENTECONTADOR;
 
  UPDATE T_ESTADISTICA7
     SET CONTA_CONSUMOMEDIO =nvl(valor/temp,CONTA_CONSUMOMEDIO)
     WHERE  ID_E7=1;
     
     
 COMMIT;




/*Excepcion en caso que el contador no este conectado y rellenamos el LOG*/    
  EXCEPTION
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_NO_CONECTADO THEN
      resultado := 'KO: La contador no esta conectado a ninguna central de produccion';
  
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LECTURA',p_entrada,' ', resultado);
      COMMIT;

   
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_LECTURA_EXISTE THEN
      resultado := 'KO: La lectura ya existe';
  
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LECTURA',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LECTURA',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA LECTURA',p_entrada,' ', resultado);
      COMMIT;     
  END PR_ALTA_LECTURA;  
  
  
  /*************************************************************************
PROCEDURE PR_BAJA_LECTURA Realiza la baja de un registro de la tabla T_LECTURA

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_lectura   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_LECTURA ( p_id_lecturas IN T_LECTURAS.ID_LECTURAS%TYPE,
                                resultado       OUT VARCHAR2)
IS


/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   valor         NUMBER;
   valor2        NUMBER;
   conta         Number;
   tempdate      DATE;
   tempdate2     DATE;
   p_id_centralprod NUMBER;

   BEGIN

      p_entrada := 'ID_LECTURAS: '||p_id_lecturas;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_lecturas)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_LECTURAS
        WHERE ID_LECTURAS = p_id_lecturas
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;

--MODIFICAMOS EL VALOR DE LA LECTURA EN CONSUMO DEL CONTADOR 
--NO ACTUALIZAMOS LA FECHA YA QUE ENTENDEMOS QUE LA LECURA EXISTIÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Â ÃƒÂ¢Ã¢â€šÂ¬Ã¢â€žÂ¢ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬ÃƒÂ¢Ã¢â‚¬Å¾Ã‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€ Ã¢â‚¬â„¢ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â¢ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã‚Â¡ÃƒÆ’Ã¢â‚¬Å¡Ãƒâ€šÃ‚Â¬ÃƒÆ’Ã†â€™ÃƒÂ¢Ã¢â€šÂ¬Ã‚Â¦ÃƒÆ’Ã‚Â¢ÃƒÂ¢Ã¢â‚¬Å¡Ã‚Â¬Ãƒâ€¦Ã¢â‚¬Å“
    SELECT id_contador into conta
    FROM t_lecturas 
    where id_lecturas=p_id_lecturas;
    
    SELECT lectura into valor
    FROM T_LECTURAS
    WHERE id_lecturas=p_id_lecturas;
    
    
    
    
    /*comprobamos que la lectura sea del mismo mes*/
    select DATA_ULTIMALECTURA into tempdate 
    from T_CONTADOR
    where ID_CONTADOR=conta;
    
    select FECHALEC into tempdate2 
    from T_LECTURAS
    where ID_LECTURAS=p_id_lecturas;
    
    --restamos la lectura anterior a la que queremos borrar
    select max(lectura) into valor2
    from T_LECTURAS
    where tempdate2>fechalec;
  
  valor:=valor-valor2;
  
    
 if extract(month from tempdate2)=extract(month from tempdate) then 
       
        UPDATE T_CONTADOR
        SET CONSUMOMEN =nvl(CONSUMOMEN-valor,CONSUMOMEN),           
                CONSUMOTOT =nvl(CONSUMOTOT-valor,CONSUMOTOT),
                LECTURATOT=CONSUMOTOT
        WHERE  ID_CONTADOR=conta;
 else
        UPDATE T_CONTADOR
        SET     CONSUMOTOT =nvl(CONSUMOTOT-valor,CONSUMOTOT),
                LECTURATOT=CONSUMOTOT
        WHERE  ID_CONTADOR=conta;
 
 end if;       
    
    
/*AQUI ACTUALIZAMOS TABLA DE ESTADISTICA 1 (consumo de contadores que depende de la central)*/
 
 SELECT DISTINCT T_PRODUC_DIS.ID_CENTRALPROD into p_id_centralprod
 from T_CONTADOR,T_CON_CENTRALES,T_CENTRALESDISTRIBUCION,T_PRODUC_DIS
 where (conta=T_CON_CENTRALES.ID_CONTADOR)and (T_CON_CENTRALES.ID_CENTRALDIS=T_CENTRALESDISTRIBUCION.ID_CENTRALDIS) and
 (T_CENTRALESDISTRIBUCION.ID_CENTRALDIS=T_PRODUC_DIS.ID_CENTRALDIS); 
    
     
     UPDATE T_ESTADISTICA1
        SET CONSUM_TOTAL =nvl((CONSUM_TOTAL-valor),CONSUM_TOTAL)             
     WHERE  ID_CENTRALPROD=p_id_centralprod;
     

     
    
      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_LECTURAS
   	WHERE ID_LECTURAS = p_id_lecturas;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LECTURA',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La lectura a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LECTURA',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_CON_CENTRALES no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LECTURA',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA LECTURA',p_entrada,' ', resultado);

        COMMIT; 

  END PR_BAJA_LECTURA;
                                
/*************************************************************************
PROCEDURE PR_MODI_LECTURA Modifica un registro de la tabla T_LECTURAS

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_id_lecturas      Necesario
                               p_id_contador      Opcional
                               p_fechalec         Opcional
                               p_telematica       Opcional
                               p_lectura          Opcional
	Modifica:	       resultado       
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La lectura no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_LECTURAS(  p_id_lecturas  IN T_LECTURAS.ID_LECTURAS%TYPE,
                             p_id_contador  IN T_LECTURAS.ID_CONTADOR%TYPE,
                             p_fechalec     IN T_LECTURAS.FECHALEC%TYPE, 
                             p_telematica   IN T_LECTURAS.TELEMATICA%TYPE,
                             p_lectura      IN T_LECTURAS.LECTURA%TYPE,    
		             resultado            OUT VARCHAR2)  
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
    p_entrada:='ID LECTURAS: '||p_id_lecturas|| ',ID CONTADOR: '||p_id_contador||', FECHA LECTURA:'||p_fechalec||', TELEMATICA:'||p_telematica||',LECTURA:'||p_lectura;
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_lecturas)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_LECTURAS
        WHERE ID_LECTURAS=p_id_lecturas
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
           
     UPDATE T_LECTURAS                  
                             
        SET ID_CONTADOR  =nvl(p_id_contador,ID_CONTADOR),
            FECHALEC     =nvl(p_fechalec,FECHALEC),
            TELEMATICA   =nvl(p_telematica ,TELEMATICA),
            LECTURA      =nvl(p_lectura,LECTURA)
                                  
     WHERE  ID_LECTURAS=p_id_lecturas;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LECTURAS',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La lectura a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LECTURAS',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_LECTURAS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LECTURAS',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA LECTURAS',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_LECTURAS;  

                          
END "AMBLECTURAS";
/
 
REM TF2 ABMCDISTRI

  CREATE OR REPLACE PACKAGE "TF2"."ABMCDISTRI" AS

/****************************************************************************
PROCEDURE PR_ALTA_CDISTRI Realiza el alta de la tabla T_CENTRALESDISTRIBUCION
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_maximodis         Necesaria
                           p_id_direccion      Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_CDISTRI( p_maximodis IN T_CENTRALESDISTRIBUCION.MAXIMODIS%TYPE,
                           p_id_direccion IN T_CENTRALESDISTRIBUCION.ID_DIRECCION%TYPE,
                           resultado             OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_BAJA_CDISTRI Realiza la baja un registro de la tabla T_CENTRALDISTRIBUCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centraldis    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CDISTRI ( p_id_centraldistri IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                                resultado       OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_MODI_CDISTRI Modifica un registro de la tabla T_CENTRALDISTRIBUCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centraldis    Necesaria
                                 p_maximodis        Opcional
                                 p_id_direccion     Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CDISTRI ( p_id_centraldis IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                            p_maximodis      IN T_CENTRALESDISTRIBUCION.MAXIMODIS%TYPE,
                            p_id_direccion  IN T_CENTRALESDISTRIBUCION.ID_DIRECCION%TYPE,
                            resultado       OUT VARCHAR2);                                
END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."ABMCDISTRI" AS

/****************************************************************************
PROCEDURE PR_ALTA_CDISTRI Realiza el alta de la tabla T_CENTRALESDISTRIBUCION
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_maximodis         Necesaria
                           p_id_direccion      Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_CDISTRI( p_maximodis    IN T_CENTRALESDISTRIBUCION.MAXIMODIS%TYPE,
                           p_id_direccion IN T_CENTRALESDISTRIBUCION.ID_DIRECCION%TYPE,
                           resultado             OUT VARCHAR2)
IS
   E_CAMPO_VACIO EXCEPTION;
   E_EXISTE      EXCEPTION;
   E_VALORP_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

BEGIN
     	p_entrada := 'MAXIMO DISTRIBUCION: '||p_maximodis||', ID DIRECCION: '||p_id_direccion;
     	/*Verifica que todos los campos obligatorios tengan valor (pais, localidad, codigopostal, via,numero)*/

    	IF ((TRIM(p_maximodis)IS NULL) OR (TRIM(p_id_direccion)IS NULL)) THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;

     /*Verifica que no exista la central */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CENTRALESDISTRIBUCION
       	       	WHERE (MAXIMODIS=p_maximodis and ID_DIRECCION=p_id_direccion)
          	AND ROWNUM  = 1;
          	RAISE E_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
    /*Verifica que exista la direccion */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END; 


      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla  y rellenamos el LOG*/

      INSERT INTO T_CENTRALESDISTRIBUCION (MAXIMODIS, ID_DIRECCION)
           VALUES (p_maximodis,p_id_direccion);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista la central rellenamos el LOG*/    
    WHEN E_EXISTE THEN
      resultado := 'KO: La central ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
       /*Excepcion en caso que exista la direccion rellenamos el LOG*/  
        WHEN  E_VALORP_NOEXISTE THEN
      resultado := 'KO: La direccion no  existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
     
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;                             
END PR_ALTA_CDISTRI;


/*************************************************************************
PROCEDURE PR_BAJA_CDISTRI Realiza la baja de un registro de la tabla T_CENTRALDISTRIBUCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centraldis    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CDISTRI ( p_id_centraldistri IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_CENTRALDIS: '||p_id_centraldistri;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_centraldistri)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS = p_id_centraldistri
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_CENTRALESDISTRIBUCION 
   	WHERE ID_CENTRALDIS = p_id_centraldistri;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la direccion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La central a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_CENTRALDISTRI no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_CDISTRI;

/*************************************************************************
PROCEDURE PR_MODI_CDISTRI Modifica un registro de la tabla T_CENTRALDISTRIBUCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centraldis    Necesaria
                                 p_maximodis        Opcional
                                 p_id_direccion     Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CDISTRI ( p_id_centraldis    IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                            p_maximodis        IN T_CENTRALESDISTRIBUCION.MAXIMODIS%TYPE,
                            p_id_direccion  IN T_CENTRALESDISTRIBUCION.ID_DIRECCION%TYPE,
                            resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;


   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

     p_entrada := 'P_IDCENTRALDISTRI: '||p_id_centraldis||', P_MAXIMODIS: '||p_maximodis||', P_ID_DIRECCION: '||p_id_direccion;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_centraldis)     IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     --Verifica que la Central exista en la Base de datos
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS =p_id_centraldis
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
        --Verifica que la direccion exista en la Base de datos  
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
      END;

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

     UPDATE T_CENTRALESDISTRIBUCION
        SET  MAXIMODIS   = nvl(p_maximodis, MAXIMODIS),
             ID_DIRECCION= nvl(p_id_direccion, ID_DIRECCION)
             
     WHERE   ID_CENTRALDIS      = p_id_centraldis;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICACION CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La central a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_VALORP_NOEXISTE THEN
        resultado := 'KO: La direccion no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
            


      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CENTRALDIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICACION CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICACION CENTRAL DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_CDISTRI;                                

END "ABMCDISTRI";
/
 
REM TF2 ABMDIRE

  CREATE OR REPLACE PACKAGE "TF2"."ABMDIRE" AS
/********************************************************************************
PROCEDURE PR_ALTA_DIRECCIONES Realiza el alta de la tabla direcciones
Parametros de entrada:           p_pais       	 IN T_DIRECCIONES.PAIS%TYPE,
                          	 p_localidad     IN T_DIRECCIONES.LOCALIDAD%TYPE,
                            	 p_codigopostal  IN T_DIRECCIONES.CODIGOPOSTAL%TYPE,
                             	 p_tipo_via      IN T_DIRECCIONES.TIPO_VIA%TYPE,
                            	 p_via           IN T_DIRECCIONES.VIA%TYPE,
                            	 p_numero	 IN T_DIRECCIONES.NUMERO%TYPE,
				 p_piso		 IN T_DIRECCIONES.PISO%TYPE,
	Modifica:		 resultado       OUT VARCHAR2);
*********************************************************************************/
  PROCEDURE PR_ALTA_DIRECCIONES (p_pais       	 IN T_DIRECCIONES.PAIS%TYPE,
                          	 p_localidad     IN T_DIRECCIONES.LOCALIDAD%TYPE,
                            	 p_codigopostal  IN T_DIRECCIONES.CODIGOPOSTAL%TYPE,
                             	 p_tipo_via      IN T_DIRECCIONES.TIPO_VIA%TYPE,
                            	 p_via           IN T_DIRECCIONES.VIA%TYPE,
                            	 p_numero	 IN T_DIRECCIONES.NUMERO%TYPE,
				 p_piso		 IN T_DIRECCIONES.PISO%TYPE,
				 resultado       OUT VARCHAR2);
                                 
                                 
/*************************************************************************
PROCEDURE PR_BAJA_DIRECCIONES Realiza la baja de la tabla direcciones

Es obligatorio introducir los campos necesario y que la direccion exista.

Parametros de entrada:         
                                 p_id_direccion    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_DIRECCIONES ( p_id_direccion IN T_DIRECCIONES.ID_DIRECCION%TYPE,
                                resultado       OUT VARCHAR2);
                                
/*************************************************************************
PROCEDURE PR_MODI_DIRECCIONES Modifica un registro de la tabla T_DIRECCIONES

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_direcciones Necesario
                                 p_pais       	  Opcional
                          	 p_localidad      Opcional
                            	 p_codigopostal   Opcional
                             	 p_tipo_via       Opcional
                            	 p_via            Opcional
                            	 p_numero	  Opcional
				 p_piso		  Opcional
	Modifica:	         resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_DIRECCIONES( p_id_direcciones IN T_DIRECCIONES.ID_DIRECCION%TYPE,
                               p_pais          IN T_DIRECCIONES.PAIS%TYPE,
                               p_localidad     IN T_DIRECCIONES.LOCALIDAD%TYPE,
                               p_codigopostal  IN T_DIRECCIONES.CODIGOPOSTAL%TYPE,
                               p_tipo_via      IN T_DIRECCIONES.TIPO_VIA%TYPE,
                               p_via           IN T_DIRECCIONES.VIA%TYPE,
                               p_numero	       IN T_DIRECCIONES.NUMERO%TYPE,
                               p_piso	       IN T_DIRECCIONES.PISO%TYPE,
                               resultado            OUT VARCHAR2); 
  END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."ABMDIRE" AS
/*************************************************************************
PROCEDURE PR_ALTA_DIRECCIONES Realiza el alta de la tabla direcciones

Es obligatorio introducir los campos necesario y que el centro no exista.

Parametros de entrada:         
                                 p_pais       	   Necesaria
                          	 p_localidad       Necesaria
                            	 p_codigopostal    Necesaria
                             	 p_tipo_via        Opcional
                            	 p_via             Necesaria
                            	 p_numero	   Necesaria
				 p_piso		   Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion ya existe'
                'KO:  Error' error de oracle 
***********************************************************************/
  PROCEDURE PR_ALTA_DIRECCIONES (p_pais       	 IN T_DIRECCIONES.PAIS%TYPE,
                          	 p_localidad     IN T_DIRECCIONES.LOCALIDAD%TYPE,
                            	 p_codigopostal  IN T_DIRECCIONES.CODIGOPOSTAL%TYPE,
                             	 p_tipo_via      IN T_DIRECCIONES.TIPO_VIA%TYPE,
                            	 p_via           IN T_DIRECCIONES.VIA%TYPE,
                            	 p_numero	 IN T_DIRECCIONES.NUMERO%TYPE,
				 p_piso		 IN T_DIRECCIONES.PISO%TYPE,
				 resultado             OUT VARCHAR2)
is
  /* Declaramos variables locales*/
  
   E_CAMPO_VACIO           EXCEPTION;
   E_DIRECCION_EXISTE      EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

BEGIN
     	p_entrada := 'PAIS: '||p_pais||', LOCALIDAD:'||p_localidad||', CODIGOPOSTAL:'||	p_codigopostal||',TIPO_VIA:'||p_tipo_via||', VIA: '||p_via||', NUMERO: '||p_numero||', 	PISO:'||p_piso;

     	/*Verifica que todos los campos obligatorios tengan valor (pais, localidad, codigopostal, via,numero)*/

    	IF (TRIM(p_pais)     IS NULL) THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	IF (TRIM(p_localidad)     IS NULL) THEN
        	RAISE E_CAMPO_VACIO;
      	END IF;
     	IF (TRIM(p_codigopostal)     IS NULL) THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	IF (TRIM(p_via)     IS NULL)  THEN
         RAISE E_CAMPO_VACIO;
      	END IF;
     	IF (TRIM(p_numero)     IS NULL) THEN
         RAISE E_CAMPO_VACIO;
      	END IF;

     /*Verifica que no exista la direccion */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_DIRECCIONES
       	       	WHERE (PAIS  = p_pais and LOCALIDAD = p_localidad and VIA=p_via and NUMERO=p_numero and PISO=p_piso)
          	AND ROWNUM  = 1;
          	RAISE E_DIRECCION_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/

      INSERT INTO T_DIRECCIONES (PAIS, LOCALIDAD, CODIGOPOSTAL, TIPO_VIA, VIA, NUMERO, PISO)
           VALUES (p_pais, p_localidad, p_codigopostal, p_tipo_via, p_via,p_numero,p_piso);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
   /*Excepcion en caso que la direccion ya exista rellenamos el LOG*/  
    WHEN E_DIRECCION_EXISTE THEN
      resultado := 'KO: La direccion ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

  END PR_ALTA_DIRECCIONES;

/*************************************************************************
PROCEDURE PR_BAJA_DIRECCIONES Realiza la baja de la tabla direcciones

Es obligatorio introducir los campos necesario y que la direccion exista.

Parametros de entrada:         
                                 p_id_direccion    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_DIRECCIONES ( p_id_direccion IN T_DIRECCIONES.ID_DIRECCION%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(10000);


   BEGIN

      p_entrada := 'P_ID_DIRECCION: '||p_id_direccion;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_direccion)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la direccion */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION = p_id_direccion
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_DIRECCIONES 
   	WHERE ID_DIRECCION = p_id_direccion;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la direccion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La direccion a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA DIRECCIONES',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_DIRECCION no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA DIRECCIONES',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 500);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA DIRECCIONES',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_DIRECCIONES;


/*************************************************************************
PROCEDURE PR_MODI_DIRECCIONES Modifica un registro de la tabla T_DIRECCIONES

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_direcciones Necesario
                                 p_pais       	  Opcional
                          	 p_localidad      Opcional
                            	 p_codigopostal   Opcional
                             	 p_tipo_via       Opcional
                            	 p_via            Opcional
                            	 p_numero	  Opcional
				 p_piso		  Opcional
	Modifica:	         resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_DIRECCIONES( p_id_direcciones IN T_DIRECCIONES.ID_DIRECCION%TYPE,
                               p_pais          IN T_DIRECCIONES.PAIS%TYPE,
                               p_localidad     IN T_DIRECCIONES.LOCALIDAD%TYPE,
                               p_codigopostal  IN T_DIRECCIONES.CODIGOPOSTAL%TYPE,
                               p_tipo_via      IN T_DIRECCIONES.TIPO_VIA%TYPE,
                               p_via           IN T_DIRECCIONES.VIA%TYPE,
                               p_numero	       IN T_DIRECCIONES.NUMERO%TYPE,
                               p_piso	       IN T_DIRECCIONES.PISO%TYPE,
                               resultado            OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
    p_entrada := 'ID DIRECCIONES: '||p_id_direcciones||', PAIS: '||p_pais||', LOCALIDAD:'||p_localidad||', CODIGOPOSTAL:'||	p_codigopostal||',TIPO_VIA:'||p_tipo_via||', VIA: '||p_via||', NUMERO: '||p_numero||', 	PISO:'||p_piso;
    
     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_direcciones)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direcciones
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

     UPDATE T_DIRECCIONES
        SET PAIS          =nvl(p_pais,PAIS),
            LOCALIDAD     =nvl(p_localidad,LOCALIDAD),
            CODIGOPOSTAL  =nvl( p_codigopostal,CODIGOPOSTAL),
            TIPO_VIA      =nvl(p_tipo_via,TIPO_VIA),
            VIA           =nvl(p_via ,VIA),
            NUMERO        =nvl(p_numero	,NUMERO),
            PISO          =nvl(p_piso,PISO)
                                  
     WHERE  ID_DIRECCION=p_id_direcciones;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La direccion a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_DIRECCION no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA DIRECCIONES',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_DIRECCIONES;  
            


END "ABMDIRE";
/
 
REM TF2 ABMCPRODUC

  CREATE OR REPLACE PACKAGE "TF2"."ABMCPRODUC" as
/*********************************************************************************
PROCEDURE PR_ALTA_TIPOCENTRAL Realiza el alta de la tabla T_TIPOCENTRAL
Es obligatorio introducir los campos necesario y que el tipo de central no exista.

Parametros de entrada:         p_energiamin       opcional
                               p_kgradioactivos   opcional
                               p_emisionesco2     opcional
                               p_nmolinos         opcional
                               p_minpaneles       opcional
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El tipo central ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_TIPOCENTRAL( p_energiamin IN T_TIPOCENTRAL.ENERGIAMIN%TYPE,
                           p_kgradioactivos IN T_TIPOCENTRAL.KGRADIOACTIVOS%TYPE,
                           p_emisionesco2 IN T_TIPOCENTRAL.EMISIONESCO2%TYPE,
                           p_nmolinos IN T_TIPOCENTRAL.NMOLINOS%TYPE,
                           p_minpaneles IN T_TIPOCENTRAL.MINPANELES%TYPE,
		           resultado            OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_BAJA_TIPOCENTRAL Realiza la baja de un registro de la tabla T_TIPOCENTRAL

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_tipocentral    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El tipo no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_TIPOCENTRAL ( p_id_tipocentral IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                                resultado       OUT VARCHAR2);

/*************************************************************************
PROCEDURE PR_MODI_TIPOCENTRAL Modifica un registro de la tabla T_TIPOCENTRAL

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:         p_id_tipocentral   Necesaria
                               p_energiamin       opcional
                               p_kgradioactivos   opcional
                               p_emisionesco2     opcional
                               p_nmolinos         opcional
                               p_minpaneles       opcional
	Modifica:	       resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_TIPOCENTRAL( p_id_tipocentral IN T_TIPOCENTRAL.ID_TIPOCENTRAL%TYPE,
                               p_energiamin IN T_TIPOCENTRAL.ENERGIAMIN%TYPE,
                               p_kgradioactivos IN T_TIPOCENTRAL.KGRADIOACTIVOS%TYPE,
                               p_emisionesco2 IN T_TIPOCENTRAL.EMISIONESCO2%TYPE,
                               p_nmolinos IN T_TIPOCENTRAL.NMOLINOS%TYPE,
                               p_minpaneles IN T_TIPOCENTRAL.MINPANELES%TYPE,
                               resultado            OUT VARCHAR2); 
/****************************************************************************
PROCEDURE PR_ALTA_CPRODUC Realiza el alta de la tabla T_CENTRALESPRODUCCION
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_id_direccion         Necesaria
                           p_codigo_central_prod  Necesaria
                           p_historicoenergia     Necesaria
                           p_energiamax           Necesaria
                           p_ultimainspeccion     Opcional
                           p_id_tipocentral       Necesaria
                           p_energia_generada     Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_CPRODUC( p_id_direccion IN T_CENTRALESPRODUCCION.ID_DIRECCION%TYPE,
                           p_codigo_central_prod IN T_CENTRALESPRODUCCION.CODIGO_CENTRAL_PROD%TYPE,
                           p_historicoenergia IN T_CENTRALESPRODUCCION.HISTORICOENERGIA%TYPE,
                           p_energiamax IN T_CENTRALESPRODUCCION.ENERGIAMAX%TYPE,
                           p_ultimainspeccion IN T_CENTRALESPRODUCCION.ULTIMAINSPECCION%TYPE,
                           p_id_tipocentral IN T_CENTRALESPRODUCCION.ID_TIPOCENTRAL%TYPE,
                           p_energia_generada IN T_CENTRALESPRODUCCION.ENERGIA_GENERADA%TYPE,
		           resultado             OUT VARCHAR2);
                           
/*************************************************************************
PROCEDURE PR_BAJA_CPRODUC Realiza la baja de un registro de la tabla T_CENTRALPRODUCCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centralprod   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CPRODUC ( p_id_centralprod IN T_CENTRALESPRODUCCION.ID_CENTRALPROD%TYPE,
                                resultado       OUT VARCHAR2);   
/*************************************************************************
PROCEDURE PR_MODI_CPRODUC Modifica un registro de la tabla T_CENTRALESPRODUCCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:        p_id_centralprod       Necesaria
                              p_id_direccion         Opcional
                              p_codigo_central_prod  Opcional
                              p_historicoenergia     Opcional
                              p_energiamax           Opcional
                              p_ultimainspeccion     Opcional
                              p_id_tipocentral       Opcional
	Modifica:	       resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CPRODUC( p_id_centralprod IN T_CENTRALESPRODUCCION.ID_CENTRALPROD%TYPE,
                           p_id_direccion IN T_CENTRALESPRODUCCION.ID_DIRECCION%TYPE,
                           p_codigo_central_prod IN T_CENTRALESPRODUCCION.CODIGO_CENTRAL_PROD%TYPE,
                           p_historicoenergia IN T_CENTRALESPRODUCCION.HISTORICOENERGIA%TYPE,
                           p_energiamax IN T_CENTRALESPRODUCCION.ENERGIAMAX%TYPE,
                           p_ultimainspeccion IN T_CENTRALESPRODUCCION.ULTIMAINSPECCION%TYPE,
                           p_id_tipocentral IN T_CENTRALESPRODUCCION.ID_TIPOCENTRAL%TYPE,
                           p_energia_generada IN T_CENTRALESPRODUCCION.ENERGIA_GENERADA%TYPE,
		           resultado             OUT VARCHAR2);
                           
/****************************************************************************
PROCEDURE PR_ALTA_CRODUCDIS Realiza el alta de la tabla T_PRODUC_DIS
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_id_centralprod       Necesaria
                           p_id_centraldis        Necesaria
                           p_id_lineacom          Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_PRODUCDIS(p_id_centralprod IN T_PRODUC_DIS.ID_CENTRALPROD%TYPE,
                             p_id_centraldis  IN T_PRODUC_DIS.ID_CENTRALDIS %TYPE,
                             p_id_lineacom    IN T_PRODUC_DIS.ID_LINEACOM %TYPE,
		             resultado             OUT VARCHAR2);
 /*************************************************************************
PROCEDURE PR_BAJA_PRODUC_DIS Realiza la baja de un registro de la tabla T_PRODUC_DIS

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_productdis   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_PRODUCDIS ( p_id_productdis IN T_PRODUC_DIS.ID_PRODUCT_DIS%TYPE,
                                resultado       OUT VARCHAR2);                            
/****************************************************************************
PROCEDURE PR_MODI_CRODUCDIS Modifica registro de la tabla T_PRODUC_DIS
Es obligatorio introducir los campos necesarios y que la asociacion no exista.

Parametros de entrada:     p_id_produc_dis        Necesaria
                           p_id_centralprod       Opcional
                           p_id_centraldis        Opcional
                           p_id_lineacom          Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_MODI_PRODUCDIS(p_id_product_dis   IN T_PRODUC_DIS.ID_PRODUCT_DIS%TYPE,
                             p_id_centralprod IN T_PRODUC_DIS.ID_CENTRALPROD%TYPE,
                             p_id_centraldis  IN T_PRODUC_DIS.ID_CENTRALDIS %TYPE,
                             p_id_lineacom    IN T_PRODUC_DIS.ID_LINEACOM %TYPE,
		             resultado             OUT VARCHAR2);                             
END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."ABMCPRODUC" AS
/****************************************************************************
PROCEDURE PR_ALTA_TIPOCENTRAL Realiza el alta de la tabla T_TIPOCENTRAL

Es obligatorio introducir los campos necesario y que el centro no exista.

Parametros de entrada:         
                               p_energiamin       opcional
                               p_kgradioactivos   opcional
                               p_emisionesco2     opcional
                               p_nmolinos         opcional
                               p_minpaneles       opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/

PROCEDURE PR_ALTA_TIPOCENTRAL( p_energiamin     IN T_TIPOCENTRAL.ENERGIAMIN%TYPE,
                               p_kgradioactivos IN T_TIPOCENTRAL.KGRADIOACTIVOS%TYPE,
                               p_emisionesco2   IN T_TIPOCENTRAL.EMISIONESCO2%TYPE,
                               p_nmolinos       IN T_TIPOCENTRAL.NMOLINOS%TYPE,
                               p_minpaneles     IN T_TIPOCENTRAL.MINPANELES%TYPE,
		               resultado            OUT VARCHAR2)                    
is

   E_CAMPO_VACIO           EXCEPTION;
   E_EXISTE      EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);

BEGIN
     	p_entrada := 'ENERGIA MINIMA: '||p_energiamin||', KG RADIOACTIVOS:'||p_kgradioactivos||', EMISIONES CO2:'||p_emisionesco2||', N MOLINOS:'||p_nmolinos||',MIN. PANELES: '||p_minpaneles;

     /*Verifica que no exista el tipo de central */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_TIPOCENTRAL
       	       	WHERE (ENERGIAMIN  = p_energiamin and KGRADIOACTIVOS=p_kgradioactivos and EMISIONESCO2=p_emisionesco2 and NMOLINOS=p_nmolinos and MINPANELES=p_minpaneles)
          	AND ROWNUM  = 1;
          	RAISE E_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
      
          IF (TRIM(p_energiamin)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/

      INSERT INTO T_TIPOCENTRAL (ENERGIAMIN,KGRADIOACTIVOS,EMISIONESCO2,NMOLINOS,MINPANELES)
           VALUES (p_energiamin,p_kgradioactivos,p_emisionesco2,p_nmolinos,p_minpaneles);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista la central rellenamos el LOG*/    
    WHEN E_EXISTE THEN
      resultado := 'KO: El tipo de central ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar la energia minima';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;
      
end PR_ALTA_TIPOCENTRAL;

/*************************************************************************
PROCEDURE PR_BAJA_TIPOCENTRAL Realiza la baja de un registro de la tabla T_TIPOCENTRAL

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centraldis    Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_TIPOCENTRAL ( p_id_tipocentral IN T_CENTRALESDISTRIBUCION.ID_CENTRALDIS%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_TIPOCENTRAL: '||p_id_tipocentral;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_tipocentral)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_TIPOCENTRAL
        WHERE ID_TIPOCENTRAL = p_id_tipocentral
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_TIPOCENTRAL 
   	WHERE ID_TIPOCENTRAL = p_id_tipocentral;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la direccion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: El tipo de central a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO CENTRAL',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_TIPOCENTRAL no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO CENTRAL',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO CENTRAL',p_entrada,' ', resultado);
        COMMIT;

END PR_BAJA_TIPOCENTRAL;                                
                                
/*************************************************************************
PROCEDURE PR_MODI_TIPOCENTRAL Modifica un registro de la tabla T_TIPOCENTRAL

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:         p_id_tipocentral   Necesaria
                               p_energiamin       opcional
                               p_kgradioactivos   opcional
                               p_emisionesco2     opcional
                               p_nmolinos         opcional
                               p_minpaneles       opcional
	Modifica:	       resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_TIPOCENTRAL( p_id_tipocentral IN T_TIPOCENTRAL.ID_TIPOCENTRAL%TYPE,
                               p_energiamin IN T_TIPOCENTRAL.ENERGIAMIN%TYPE,
                               p_kgradioactivos IN T_TIPOCENTRAL.KGRADIOACTIVOS%TYPE,
                               p_emisionesco2 IN T_TIPOCENTRAL.EMISIONESCO2%TYPE,
                               p_nmolinos IN T_TIPOCENTRAL.NMOLINOS%TYPE,
                               p_minpaneles IN T_TIPOCENTRAL.MINPANELES%TYPE,
                               resultado            OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

     p_entrada := 'P_IDTIPOCENTRAL: '||p_id_tipocentral||'ENERGIA MINIMA: '||p_energiamin||', KG RADIOACTIVOS:'||p_kgradioactivos||', EMISIONES CO2:'||p_emisionesco2||', N MOLINOS:'||p_nmolinos||',MIN. PANELES: '||p_minpaneles;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_tipocentral)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que el tipo de central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_TIPOCENTRAL
        WHERE ID_TIPOCENTRAL=p_id_tipocentral
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

     UPDATE T_TIPOCENTRAL
        SET ENERGIAMIN      =nvl(p_energiamin, ENERGIAMIN),
            KGRADIOACTIVOS  =nvl(p_kgradioactivos, KGRADIOACTIVOS),
            EMISIONESCO2    =nvl(p_emisionesco2, EMISIONESCO2),
            NMOLINOS        =nvl(p_nmolinos,NMOLINOS),
            MINPANELES      =nvl(p_minpaneles,MINPANELES)      
             
     WHERE  ID_TIPOCENTRAL=p_id_tipocentral;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: El tipo a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CENTRALDIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA TIPO CENTRAL',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_TIPOCENTRAL;


                        

/****************************************************************************
PROCEDURE PR_ALTA_CPRODUC Realiza el alta de la tabla T_CENTRALESPRODUCCION
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_id_direccion         Necesaria
                           p_codigo_central_prod  Necesaria
                           p_historicoenergia     Necesaria
                           p_energiamax           Necesaria
                           p_ultimainspeccion     Opcional
                           p_id_tipocentral       Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La direccion ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_CPRODUC( p_id_direccion IN T_CENTRALESPRODUCCION.ID_DIRECCION%TYPE,
                           p_codigo_central_prod IN T_CENTRALESPRODUCCION.CODIGO_CENTRAL_PROD%TYPE,
                           p_historicoenergia IN T_CENTRALESPRODUCCION.HISTORICOENERGIA%TYPE,
                           p_energiamax IN T_CENTRALESPRODUCCION.ENERGIAMAX%TYPE,
                           p_ultimainspeccion IN T_CENTRALESPRODUCCION.ULTIMAINSPECCION%TYPE,
                           p_id_tipocentral IN T_CENTRALESPRODUCCION.ID_TIPOCENTRAL%TYPE,
		           p_energia_generada IN T_CENTRALESPRODUCCION.ENERGIA_GENERADA%TYPE,
                           resultado            OUT VARCHAR2)

is

   E_CAMPO_VACIO EXCEPTION;
   E_EXISTE      EXCEPTION;
   E_VALORP_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   valor         NUMBER;
   ano           NUMBER;

BEGIN
     	p_entrada := 'ID DIRECCION: '||p_id_direccion||', CODIGO CENTRAL PRODUCCION: '||p_codigo_central_prod||', HISTORICO ENERGIA CONSUMIDA: '||p_historicoenergia||', ENERGIA MAXIMA: '||p_energiamax||',FECHA ULTIAM INSPECCION: '||p_ultimainspeccion||', ID_TIPO CENTRAL: ' ||p_id_tipocentral;
     	/*Verifica que todos los campos obligatorios tengan valor (pais, localidad, codigopostal, via,numero)*/

    	IF ((TRIM(p_id_direccion)IS NULL) OR (TRIM(p_codigo_central_prod)IS NULL) OR (TRIM(p_historicoenergia)IS NULL) OR (TRIM(p_energiamax)IS NULL) OR (TRIM(p_ultimainspeccion)IS NULL) OR (TRIM(p_id_tipocentral)IS NULL)  IS NULL) THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;

     /*Verifica que no exista el tipo de central */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CENTRALESPRODUCCION
       	       	WHERE (ID_DIRECCION=p_id_direccion and CODIGO_CENTRAL_PROD=p_codigo_central_prod and HISTORICOENERGIA=p_historicoenergia and ENERGIAMAX=p_energiamax and ULTIMAINSPECCION=p_ultimainspeccion and ID_TIPOCENTRAL= p_id_tipocentral)
          	AND ROWNUM  = 1;
          	RAISE E_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
       /*Verifica que exista la direccion y el tipo central*/
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_TIPOCENTRAL
        WHERE ID_TIPOCENTRAL=p_id_tipocentral
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;

      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla  y rellenamos el LOG*/

      INSERT INTO T_CENTRALESPRODUCCION (ID_DIRECCION, CODIGO_CENTRAL_PROD, HISTORICOENERGIA,ENERGIAMAX,ULTIMAINSPECCION,ID_TIPOCENTRAL,ENERGIA_GENERADA)
           VALUES (p_id_direccion,p_codigo_central_prod, p_historicoenergia, p_energiamax, p_ultimainspeccion, p_id_tipocentral,p_energia_generada);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;


/* CREAMOS LA CENTRAL EN LA TABLA DE ESTADISTICA 1*/
     
     SELECT ID_CENTRALPROD into valor
     from T_CENTRALESPRODUCCION
     WHERE (ID_DIRECCION=p_id_direccion and CODIGO_CENTRAL_PROD=p_codigo_central_prod and HISTORICOENERGIA=p_historicoenergia and ENERGIAMAX=p_energiamax and ULTIMAINSPECCION=p_ultimainspeccion and ID_TIPOCENTRAL= p_id_tipocentral);
     
     INSERT INTO T_ESTADISTICA1 (T_ESTADISTICA1.ID_CENTRALPROD,CONSUM_TOTAL)
     VALUES (valor,0);             

/* Si aiÃ‚Âºn no exite - CREAMOS LA CENTRAL EN LA TABLA DE ESTADISTICA 5*/
       
     select extract(year from sysdate)  into ano
     from dual;
 
 SELECT COUNT(*) INTO valor 
       FROM T_ESTADISTICA5
       WHERE ANO3=ANO;
       
        IF (valor) = 0 then       
          INSERT INTO T_ESTADISTICA5(ID_E5,ANO3,CENTRALESMIN30)
          VALUES (1,ano,0);
        END if;


     COMMIT;
  
  EXCEPTION
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_EXISTE THEN
      resultado := 'KO: La central ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
   /*Excepcion en caso que no exista la direccion o el tipo de centralrellenamos el LOG*/    
    WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: La direccion o el tipo de central no existen';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;  
      
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
      
END PR_ALTA_CPRODUC;


/*************************************************************************
PROCEDURE PR_BAJA_CPRODUC Realiza la baja de un registro de la tabla T_CENTRALPRODUCCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_centralprod   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CPRODUC ( p_id_centralprod IN T_CENTRALESPRODUCCION.ID_CENTRALPROD%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_CENTRALPROD: '||p_id_centralprod;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_centralprod)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CENTRALESPRODUCCION
        WHERE ID_CENTRALPROD = p_id_centralprod
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_CENTRALESPRODUCCION
   	WHERE ID_CENTRALPROD=p_id_centralprod;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
/* BORRAMOS LA CENTRAL EN LA TABLA DE ESTADISTICA 1*/
    
     DELETE FROM T_ESTADISTICA1 
     WHERE ID_CENTRALPROD=p_id_centralprod;




      /*Excepcion en caso que la direccion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La central de produccion a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL PRODUCCION',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_CENTRALPROD no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL PRODUCCION',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CENTRAL PRODUCCION',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_CPRODUC;

/*************************************************************************
PROCEDURE PR_MODI_CPRODUC Modifica un registro de la tabla T_CENTRALESPRODUCCION

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:        p_id_centralprod       Necesaria
                              p_id_direccion         Opcional
                              p_codigo_central_prod  Opcional
                              p_historicoenergia     Opcional
                              p_energiamax           Opcional
                              p_ultimainspeccion     Opcional
                              p_id_tipocentral       Opcional
	Modifica:	       resultado     
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CPRODUC( p_id_centralprod IN T_CENTRALESPRODUCCION.ID_CENTRALPROD%TYPE,
                           p_id_direccion IN T_CENTRALESPRODUCCION.ID_DIRECCION%TYPE,
                           p_codigo_central_prod IN T_CENTRALESPRODUCCION.CODIGO_CENTRAL_PROD%TYPE,
                           p_historicoenergia IN T_CENTRALESPRODUCCION.HISTORICOENERGIA%TYPE,
                           p_energiamax IN T_CENTRALESPRODUCCION.ENERGIAMAX%TYPE,
                           p_ultimainspeccion IN T_CENTRALESPRODUCCION.ULTIMAINSPECCION%TYPE,
                           p_id_tipocentral IN T_CENTRALESPRODUCCION.ID_TIPOCENTRAL%TYPE,
                           p_energia_generada IN T_CENTRALESPRODUCCION.ENERGIA_GENERADA%TYPE,
		           resultado             OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
     p_entrada :='ID CENTRALPROD: '||p_id_centralprod||'ID DIRECCION: '||p_id_direccion||', CODIGO CENTRAL PRODUCCION: '||p_codigo_central_prod||', HISTORICO ENERGIA CONSUMIDA: '||p_historicoenergia||', ENERGIA MAXIMA: '||p_energiamax||',FECHA ULTIAM INSPECCION: '||p_ultimainspeccion||', ID_TIPO CENTRAL: ' ||p_id_tipocentral;
     

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_centralprod)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CENTRALESPRODUCCION
        WHERE ID_CENTRALPROD=p_id_centralprod
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
     /*Verifica que exista la direccion y el tipo central*/
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_TIPOCENTRAL
        WHERE ID_TIPOCENTRAL=p_id_tipocentral
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;

      END;
      
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
                           
     UPDATE T_CENTRALESPRODUCCION
        SET ID_DIRECCION         =nvl(p_id_direccion,ID_DIRECCION),
            CODIGO_CENTRAL_PROD  =nvl(p_codigo_central_prod,CODIGO_CENTRAL_PROD),
            HISTORICOENERGIA     =nvl(p_historicoenergia,HISTORICOENERGIA),
            ENERGIAMAX           =nvl(p_energiamax,ENERGIAMAX),
            ULTIMAINSPECCION     =nvl(p_ultimainspeccion,ULTIMAINSPECCION),
            ID_TIPOCENTRAL       =nvl(p_id_tipocentral,ID_TIPOCENTRAL),
            ENERGIA_GENERADA     =nvl(p_energia_generada,ENERGIA_GENERADA) 
             
     WHERE  ID_CENTRALPROD=p_id_centralprod;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La central a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
   /*Excepcion en caso que no exista la direccion o el tipo de centralrellenamos el LOG*/    
    WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: La central ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;  
      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CENTRALDIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CENTRAL PRODUCCION',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_CPRODUC;                           


/****************************************************************************
PROCEDURE PR_ALTA_CRODUCDIS Realiza el alta de la tabla T_PRODUC_DIS
Es obligatorio introducir los campos necesario y que la central no exista.

Parametros de entrada:     p_id_centralprod       Necesaria
                           p_id_centraldis        Necesaria
                           p_id_lineacom          Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_ALTA_PRODUCDIS(p_id_centralprod IN T_PRODUC_DIS.ID_CENTRALPROD%TYPE,
                             p_id_centraldis  IN T_PRODUC_DIS.ID_CENTRALDIS %TYPE,
                             p_id_lineacom    IN T_PRODUC_DIS.ID_LINEACOM %TYPE,
		             resultado             OUT VARCHAR2)
                             
is
   E_CAMPO_VACIO EXCEPTION;
   E_EXISTE      EXCEPTION;
   NO_VALIDO     EXCEPTION;
   E_CAPACIDAD_LINEA EXCEPTION;
   E_VALORP_NOEXISTE EXCEPTION;
   E_VALORP_NEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   VAR_A         NUMBER;
   VAR_B         NUMBER;
   VAR_C         NUMBER;
   
   

BEGIN
     	p_entrada := 'ID CENTRAL PRODUCCION: '||p_id_centralprod||', ID CENTRAL DISTRIBUCION: '||p_id_centraldis||', ID LINEA COMUNICACION: '||p_id_lineacom;
     	/*Verifica que todos los campos obligatorios tengan valor */

    	IF ((TRIM(p_id_centralprod)IS NULL) OR (TRIM(p_id_centraldis)IS NULL) OR (TRIM(p_id_lineacom)IS NULL)) THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;

     /*Verifica que no exista el tipo de central */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_PRODUC_DIS
       	       	WHERE (ID_CENTRALPROD=p_id_centralprod and ID_CENTRALDIS=p_id_centraldis and ID_LINEACOM= p_id_lineacom)
          	AND ROWNUM  = 1;
          	RAISE E_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;

 /*Verifica que exista la central y el contador */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESPRODUCCION
        WHERE ID_CENTRALPROD=p_id_centralprod
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;      
              BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS=p_id_centraldis
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;  
      
/* validamos que la linea no alimente a mas de una central de prod  */
       BEGIN
       SELECT 'S'
         INTO existe
         FROM T_PRODUC_DIS
        WHERE ID_LINEACOM=p_id_lineacom and ID_CENTRALPROD=p_id_centralprod 
          AND ROWNUM   = 1;
             	RAISE E_VALORP_NEXISTE;
                EXCEPTION
                          WHEN NO_DATA_FOUND THEN NULL;
           	
      END;  
  
/* Comprobamos que la linea y la cdistribucion tenga capacidad para unir las centrales  */

select ENERGIAMAX into VAR_A from T_CENTRALESPRODUCCION where ID_CENTRALPROD=p_id_centralprod;
select CAPACIDADMAX-CONSUMOLINEA into VAR_B from T_LINEASCOMUNIC where p_id_lineacom=ID_LINEACOM;
select MAXIMODIS-CONSUMO into VAR_C from T_CENTRALESDISTRIBUCION where ID_CENTRALDIS=p_id_centraldis;

    if ( (VAR_A > VAR_B) OR (VAR_A > VAR_C)) then
        RAISE E_CAPACIDAD_LINEA;
    end if;
    

     

/*ACTUALIZAMOS LA CAPCIDAD DE LA LINEA y de la CENTRAL DE DISTRIBUCION*/


    UPDATE T_LINEASCOMUNIC
    SET CONSUMOLINEA  =nvl(CONSUMOLINEA+VAR_A,CONSUMOLINEA)  
    WHERE  ID_LINEACOM=p_id_lineacom;
    COMMIT;
 
    UPDATE T_CENTRALESDISTRIBUCION
    SET CONSUMO  =nvl(CONSUMO+VAR_A,CONSUMO)  
    WHERE  ID_CENTRALDIS=p_id_centraldis;
    COMMIT;



 /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

      
      INSERT INTO T_PRODUC_DIS (ID_CENTRALPROD, ID_CENTRALDIS, ID_LINEACOM)
           VALUES (p_id_centralprod,p_id_centraldis,p_id_lineacom);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT;


  EXCEPTION
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_EXISTE THEN
      resultado := 'KO: La asociacion ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT; 
       /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_VALORP_NOEXISTE THEN
     resultado := 'KO: Central inexistente';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT; 
     /*Excepcion en caso que la capacidad de la linea no sea suficiente rellenamos el LOG*/ 
      WHEN E_CAPACIDAD_LINEA THEN
     resultado := 'KO: La capacidad de linea o de la central de distribucion no es suficiente';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT;  
      /*Excepcion en caso que la capacidad de la linea no sea suficiente rellenamos el LOG*/ 
      WHEN E_VALORP_NEXISTE THEN
     resultado := 'KO: La linea solo puede conectar con una central de produccion';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT;  
  /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT; 
END PR_ALTA_PRODUCDIS;  

/*************************************************************************
PROCEDURE PR_BAJA_PRODUC_DIS Realiza la baja de un registro de la tabla T_PRODUC_DIS

Es obligatorio introducir los campos necesario y que la central exista.

Parametros de entrada:           p_id_productdis   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La central no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_PRODUCDIS ( p_id_productdis IN T_PRODUC_DIS.ID_PRODUCT_DIS%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   l            number;
   VAR_A        number;
   linea        number;
   central      number;


   BEGIN

      p_entrada := 'ID_PRODUCT_DIS: '||p_id_productdis;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_productdis)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_PRODUC_DIS
        WHERE ID_PRODUCT_DIS = p_id_productdis
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

/*ACTUALIZAMOS LA CAPCIDAD DE LA LINEA Y DE LA CDISTRIBUCION*/
select ID_LINEACOM into  linea
from T_PRODUC_DIS
where ID_PRODUCT_DIS=p_id_productdis;
 
select ID_CENTRALDIS into  central
from T_PRODUC_DIS
where ID_PRODUCT_DIS=p_id_productdis;


select count(ID_LINEACOM) into l
from T_PRODUC_DIS
WHERE ID_LINEACOM = linea;

If l >1 then 
 
 SELECT MAXIMODIS into VAR_A
 from T_CENTRALESDISTRIBUCION
 where ID_CENTRALDIS=central;
 
    UPDATE T_LINEASCOMUNIC
    SET CONSUMOLINEA  =nvl(CONSUMOLINEA-VAR_A,CONSUMOLINEA)  
    WHERE  ID_LINEACOM=linea;
    COMMIT;
    UPDATE T_CENTRALESDISTRIBUCION
    SET CONSUMO  =nvl(CONSUMO-VAR_A,CONSUMO)  
    WHERE  ID_CENTRALDIS=central;
    COMMIT;
else 
    UPDATE T_LINEASCOMUNIC
    SET CONSUMOLINEA  = 0  
    WHERE  ID_LINEACOM=linea;
    COMMIT;
    UPDATE T_CENTRALESDISTRIBUCION
    SET CONSUMO  =0 
    WHERE  ID_CENTRALDIS=central;
    COMMIT;
End if;

	DELETE FROM T_PRODUC_DIS
   	WHERE ID_PRODUCT_DIS = p_id_productdis;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CPRODUC CDISTRI',p_entrada,' ', resultado);
      COMMIT;


     /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La asociacion a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CPRODUC CDISTRI',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_PRODUC_DIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CPRODUC CDISTRI',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CPRODUC CDISTRI',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_PRODUCDIS;
/****************************************************************************
PROCEDURE PR_MODI_CRODUCDIS Modifica registro de la tabla T_PRODUC_DIS
Es obligatorio introducir los campos necesarios y que la asociacion no exista.

Parametros de entrada:     p_id_produc_dis        Necesaria
                           p_id_centralprod       Opcional
                           p_id_centraldis        Opcional
                           p_id_lineacom          Opcional
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
*****************************************************************************/
PROCEDURE PR_MODI_PRODUCDIS (p_id_product_dis IN T_PRODUC_DIS.ID_PRODUCT_DIS%TYPE,
                             p_id_centralprod IN T_PRODUC_DIS.ID_CENTRALPROD%TYPE,
                             p_id_centraldis  IN T_PRODUC_DIS.ID_CENTRALDIS %TYPE,
                             p_id_lineacom    IN T_PRODUC_DIS.ID_LINEACOM %TYPE,
		             resultado             OUT VARCHAR2) 
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   linea number;
   VAR_A number;
   l  number;


   BEGIN
    
     p_entrada :='ID CENTRALPROD: '||p_id_product_dis||'ID CENTRAL PRODUCCION: '||p_id_centralprod||', ID CENTRAL DISTRIBUCION: '||p_id_centraldis||', ID LINEA COMUNICACION: '||p_id_lineacom;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_product_dis)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_PRODUC_DIS
        WHERE ID_PRODUCT_DIS=p_id_product_dis
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      
      /*Verifica que exista la central y el contador */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESPRODUCCION
        WHERE ID_CENTRALPROD=p_id_centralprod
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;      
              BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS=p_id_centraldis
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;  
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

                   
     
     
     
     
    /*ACTUALIZAMOS LA CAPCIDAD DE LA LINEA Y DE LA CDISTRIBUCION*/
--RESTAMOS EL VALOR ACTUAL

select count(ID_LINEACOM) into l
from T_PRODUC_DIS
WHERE ID_LINEACOM = linea;

If l >1 then 
 
 SELECT MAXIMODIS into VAR_A
 from T_CENTRALESDISTRIBUCION
 where ID_CENTRALDIS=p_id_product_dis;
 
    UPDATE T_LINEASCOMUNIC
    SET CONSUMOLINEA  =nvl(CONSUMOLINEA-VAR_A,CONSUMOLINEA)  
    WHERE  ID_LINEACOM=p_id_lineacom;
    COMMIT;
    UPDATE T_CENTRALESDISTRIBUCION
    SET CONSUMO  =nvl(CONSUMO-VAR_A,CONSUMO)  
    WHERE  ID_CENTRALDIS=p_id_product_dis;
    COMMIT;
else 
    UPDATE T_LINEASCOMUNIC
    SET CONSUMOLINEA  = 0  
    WHERE  ID_LINEACOM=linea;
    COMMIT;
    UPDATE T_CENTRALESDISTRIBUCION
    SET CONSUMO  =0 
    WHERE  ID_CENTRALDIS=p_id_product_dis;
    COMMIT;
End if; 
     
     
     
     
     
     
     UPDATE T_PRODUC_DIS
        SET ID_CENTRALPROD  =nvl(p_id_centralprod,ID_CENTRALPROD),
            ID_CENTRALDIS   =nvl(p_id_centraldis,ID_CENTRALDIS),
            ID_LINEACOM     =nvl(p_id_lineacom ,ID_LINEACOM)
                             
     WHERE  ID_PRODUCT_DIS=p_id_product_dis;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CPRODUCCIO CDISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

/*ACTUALIZAMOS LA CAPCIDAD DE LA LINEA y de la CENTRAL DE DISTRIBUCION*/

--ANADIMOS EL NUEVO VALOR

select ENERGIAMAX into VAR_A from T_CENTRALESPRODUCCION where ID_CENTRALPROD=p_id_centralprod;

UPDATE T_LINEASCOMUNIC
SET CONSUMOLINEA  =nvl(CONSUMOLINEA+VAR_A,CONSUMOLINEA)  
WHERE  ID_LINEACOM=p_id_lineacom;
 COMMIT;
 
UPDATE T_CENTRALESDISTRIBUCION
SET CONSUMO  =nvl(CONSUMO+VAR_A,CONSUMO)  
WHERE  ID_CENTRALDIS=p_id_centraldis;
 COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La asociacion a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CPRODUCCIO CDISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_VALORP_NOEXISTE THEN
        resultado := 'KO: Central inexistente';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CPRODUCCIO CDISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_PRODUC_DIS no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CPRODUCCIO CDISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CPRODUCCIO CDISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_PRODUCDIS;  

END "ABMCPRODUC";
/
 
REM TF2 AMBCONTADOR

  CREATE OR REPLACE PACKAGE "TF2"."AMBCONTADOR" AS
/*********************************************************************************
PROCEDURE PR_ALTA_CONTADOR Realiza el alta de la tabla T_CONTADOR
Es obligatorio introducir los campos necesario y que el contador no exista.

Parametros de entrada:         p_potencia         opcional
                               p_id_modelo        Necesario
                               p_fecha_inst       Necesario
                               p_id_direccion     Necesario    
                               p_serialnumber     Necesario
                               p_codcontrato      Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CONTADOR(p_potencia     IN T_CONTADOR.POTENCIA%TYPE,
                           p_id_modelo    IN T_CONTADOR.ID_MODELO%TYPE, 
                           p_fecha_inst   IN T_CONTADOR.FECHA_INSTALACION%TYPE,
                           p_id_direccion IN T_CONTADOR.ID_DIRECCION%TYPE,    
                           p_serialnumber IN T_CONTADOR.SERIALNUMBER%TYPE,
                           p_codcontrato  IN T_CONTADOR.CODCONTRATO%TYPE,                           
		           resultado            OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_BAJA_CONTADOR Realiza la baja de un registro de la tabla T_CONTADOR

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_contador   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CONTADOR ( p_id_contador IN T_CONTADOR.ID_CONTADOR%TYPE,
                                resultado       OUT VARCHAR2);
/*************************************************************************
PROCEDURE PR_MODI_CONTADOR Modifica un registro de la tabla T_CONTADOR

Es obligatorio introducir los campos necesario y que la contador exista.

Parametros de entrada:         p_potencia         opcional
                               p_id_modelo        Necesario
                               p_fecha_inst       Necesario
                               p_id_direccion     Necesario    
                               p_serialnumber     Necesario
                               p_codcontrato      Necesario
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CONTADOR(p_id_contador  IN T_CONTADOR.ID_CONTADOR%TYPE,
                           p_potencia     IN T_CONTADOR.POTENCIA%TYPE,
                           p_id_modelo    IN T_CONTADOR.ID_MODELO%TYPE, 
                           p_fecha_inst   IN T_CONTADOR.FECHA_INSTALACION%TYPE,
                           p_id_direccion IN T_CONTADOR.ID_DIRECCION%TYPE,
                           p_data_ultima  IN T_CONTADOR.DATA_ULTIMALECTURA%TYPE,
                           p_serialnumber IN T_CONTADOR.SERIALNUMBER%TYPE,
                           p_codcontrato  IN T_CONTADOR.CODCONTRATO%TYPE,                           
		           resultado            OUT VARCHAR2);
           
                           
/*********************************************************************************
PROCEDURE PR_ALTA_TMODELO Realiza el alta de la tabla T_MODELO
Es obligatorio introducir los campos necesario y que el modelo de contador no exista.

Parametros de entrada:         p_modelo           opcional
                               p_fechafab         opcional
                               p_empresafab       opcional
                               p_caracteristicas  opcional
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_T_MODELO(p_modelo           IN T_MODELO.MODELO%TYPE,
                           p_fechafab         IN T_MODELO.FECHA_FABRICA%TYPE, 
                           p_empresafab       IN T_MODELO.EMPRESAFAB%TYPE,
                           p_caracteristicas  IN T_MODELO.CARACTERISTICAS%TYPE,    
                           resultado            OUT VARCHAR2);
                           
/*************************************************************************
PROCEDURE PR_BAJA_T_MODELO Realiza la baja de un registro de la tabla T_MODELO

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_modelo   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_T_MODELO ( p_id_modelo IN T_MODELO.ID_MODELO%TYPE,
                                resultado       OUT VARCHAR2);

/*************************************************************************
PROCEDURE PR_MODI_TMODELO Modifica un registro de la tabla T_TMODELO

Es obligatorio introducir los campos necesario y que el tipo modelo exista.

Parametros de entrada:         p_modelo           opcional
                               p_fechafab         opcional
                               p_empresafab       opcional
                               p_caracteristicas  opcional
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_T_MODELO (p_id_modelo        IN  T_MODELO.ID_MODELO%TYPE,
                           p_modelo           IN T_MODELO.MODELO%TYPE,
                           p_fechafab         IN T_MODELO.FECHA_FABRICA%TYPE, 
                           p_empresafab       IN T_MODELO.EMPRESAFAB%TYPE,
                           p_caracteristicas  IN T_MODELO.CARACTERISTICAS%TYPE,    
                           resultado            OUT VARCHAR2);



                 
/*********************************************************************************
PROCEDURE PR_ALTA_CONCENTRALES Realiza el alta de la tabla T_CON_CENTRALES
Es obligatorio introducir los campos necesario y que el modelo de contador no exista.

Parametros de entrada:         id_contador        Necesario
                               id_centraldis      Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CONCENTRALES(p_id_contador      IN T_CON_CENTRALES.ID_CONTADOR%TYPE,
                               p_id_centraldis    IN T_CON_CENTRALES.ID_CENTRALDIS%TYPE, 
                               resultado            OUT VARCHAR2);   
/*************************************************************************
PROCEDURE PR_BAJA_CONCENTRALES Realiza la baja de un registro de la tabla T_CON_CENTRALES

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_con_centrales   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CONCENTRALES ( p_id_con_centrales IN T_CON_CENTRALES.ID_CON_CENTRALES%TYPE,
                                resultado       OUT VARCHAR2);

/*************************************************************************
PROCEDURE PR_MODI_CONCENTRALES Modifica un registro de la tabla T_CONCENTRALES

Es obligatorio introducir los campos necesario y que el tipo modelo exista.

Parametros de entrada:         id_con_centrales   Necesario
                               id_contador        Opcional
                               id_centraldis      Opcional
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CONCENTRALES ( p_id_con_centrales IN T_CON_CENTRALES.ID_CON_CENTRALES%TYPE,
                                 p_id_contador      IN T_CON_CENTRALES.ID_CONTADOR%TYPE,
                                 p_id_centraldis    IN T_CON_CENTRALES.ID_CENTRALDIS%TYPE, 
                                 resultado            OUT VARCHAR2);
END;
/
CREATE OR REPLACE PACKAGE BODY "TF2"."AMBCONTADOR" AS
/*********************************************************************************
PROCEDURE PR_ALTA_CONTADOR Realiza el alta de la tabla T_CONTADOR
Es obligatorio introducir los campos necesario y que el contador no exista.

Parametros de entrada:         p_potencia         opcional
                               p_id_modelo        Necesario
                               p_fecha_inst       Necesario
                               p_id_direccion     Necesario    
                               p_serialnumber     Necesario
                               p_codcontrato      Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CONTADOR(p_potencia     IN T_CONTADOR.POTENCIA%TYPE,
                           p_id_modelo    IN T_CONTADOR.ID_MODELO%TYPE, 
                           p_fecha_inst   IN T_CONTADOR.FECHA_INSTALACION%TYPE,
                           p_id_direccion IN T_CONTADOR.ID_DIRECCION%TYPE,    
                           p_serialnumber IN T_CONTADOR.SERIALNUMBER%TYPE,
                           p_codcontrato  IN T_CONTADOR.CODCONTRATO%TYPE,                           
		           resultado            OUT VARCHAR2)
IS
  /* Declaramos variables locales*/
  
   E_CAMPO_VACIO          EXCEPTION;
   E_CONTADOR_EXISTE      EXCEPTION;
   E_VALORP_NOEXISTE      EXCEPTION;
   E_CODIGOCONTRATO_EXISTE      EXCEPTION;
   
   
   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(30000);
   valor         number;
   p_id_lineacom number;
   p_id_contador number;
   
BEGIN
     	p_entrada:= 'POTENCIA: '||p_potencia||', ID_MODELO:'||p_id_modelo||', FECHA INSTALACION:'||p_fecha_inst||',ID_DIRECCION:'||p_id_direccion||',S/N: '||p_serialnumber||', CODIGO CONTRATO: '||p_codcontrato;

     	/*Verifica que todos los campos obligatorios tengan valor ( id_modelo,fecha_inst,id_direccion,serialnumber,codcontrato*/

    	IF ((TRIM(p_id_modelo)IS NULL)or(TRIM(p_fecha_inst)IS NULL)or(TRIM(p_id_direccion)IS NULL)or(TRIM(p_serialnumber)IS NULL)or(TRIM(p_codcontrato)IS NULL)) 
          THEN
         	RAISE E_CAMPO_VACIO;
      	END IF;
     	
     /*Verifica que no exista el contador */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CONTADOR
       	       	WHERE (SERIALNUMBER=p_serialnumber)
          	AND ROWNUM  = 1;
          	RAISE E_CONTADOR_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
       /*Verifica que exista la direccion y el modelo */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_MODELO
        WHERE ID_MODELO=p_id_modelo
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;
           	
      END;  
      /*Verifica que no exista el concodigo contrato */     
     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CONTADOR
       	       	WHERE (CODCONTRATO=p_codcontrato)
          	AND ROWNUM  = 1;
          	RAISE E_CODIGOCONTRATO_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/
      

      INSERT INTO T_CONTADOR (POTENCIA,ID_MODELO,FECHA_INSTALACION,ID_DIRECCION,SERIALNUMBER,CODCONTRATO)
           VALUES (p_potencia,p_id_modelo,p_fecha_inst,p_id_direccion,p_serialnumber,p_codcontrato );

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      



COMMIT;

EXCEPTION
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_CONTADOR_EXISTE THEN
      resultado := 'KO: El contador ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que exista codigocontrato rellenamos el LOG*/    
    WHEN E_CODIGOCONTRATO_EXISTE THEN
      resultado := 'KO: El codigo de contrato ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
         /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: La direccion o modelo no existen';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
      
      
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR',p_entrada,' ', resultado);
      COMMIT;

  END PR_ALTA_CONTADOR;
  
  
  /*************************************************************************
PROCEDURE PR_BAJA_CONTADOR Realiza la baja de un registro de la tabla T_CONTADOR

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_contador   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CONTADOR ( p_id_contador IN T_CONTADOR.ID_CONTADOR%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(10000);


   BEGIN

      p_entrada := 'ID_NCONTADOR: '||p_id_contador;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_contador)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_CONTADOR = p_id_contador
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_CONTADOR
   	WHERE ID_CONTADOR = p_id_contador;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: El contador a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_CONTADOR no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 3200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR',p_entrada,' ', resultado);

        COMMIT;

  END PR_BAJA_CONTADOR;
  
  
/*************************************************************************
PROCEDURE PR_MODI_CONTADOR Modifica un registro de la tabla T_CONTADOR

Es obligatorio introducir los campos necesario y que la linea exista.

Parametros de entrada:         p_potencia         opcional
                               p_id_modelo        Necesario
                               p_fecha_inst       opcional
                               p_id_direccion     opcional    
                               p_serialnumber     opcional
                               p_codcontrato      opcional
                               
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CONTADOR(p_id_contador  IN T_CONTADOR.ID_CONTADOR%TYPE,
                           p_potencia     IN T_CONTADOR.POTENCIA%TYPE,
                           p_id_modelo    IN T_CONTADOR.ID_MODELO%TYPE, 
                           p_fecha_inst   IN T_CONTADOR.FECHA_INSTALACION%TYPE,
                           p_id_direccion IN T_CONTADOR.ID_DIRECCION%TYPE,
                           p_data_ultima  IN T_CONTADOR.DATA_ULTIMALECTURA%TYPE,
                           p_serialnumber IN T_CONTADOR.SERIALNUMBER%TYPE,
                           p_codcontrato  IN T_CONTADOR.CODCONTRATO%TYPE,
                           resultado            OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   E_VALORP_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(10000);


   BEGIN
    p_entrada:= 'ID CONTADOR: '||p_id_contador||',POTENCIA: '||p_potencia||', ID_MODELO:'||p_id_modelo||', FECHA INSTALACION:'||p_fecha_inst||',ID_DIRECCION:'||p_id_direccion||',DATA ULTIMA LECTURA:'||p_data_ultima||',S/N: '||p_serialnumber||', CODIGO CONTRATO: '||p_codcontrato;
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_contador)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_CONTADOR=p_id_contador
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Verifica que el modelo y la direccion a actualizar existan*/ 

        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_DIRECCIONES
        WHERE ID_DIRECCION=p_id_direccion
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;       
     
     BEGIN
       SELECT 'S'
         INTO existe
         FROM T_MODELO
        WHERE ID_MODELO=p_id_modelo
          AND ROWNUM   = 1;
               	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                        RAISE E_VALORP_NOEXISTE;
           	
      END;  

   
      
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/
         
     UPDATE T_CONTADOR
        SET POTENCIA           =nvl(p_potencia,POTENCIA),
            ID_MODELO          =nvl(p_id_modelo,ID_MODELO),
            FECHA_INSTALACION  =nvl(p_fecha_inst,FECHA_INSTALACION),
            DATA_ULTIMALECTURA =nvl(p_data_ultima,DATA_ULTIMALECTURA),
            ID_DIRECCION       =nvl(p_id_direccion,ID_DIRECCION),
            SERIALNUMBER       =nvl(p_serialnumber,SERIALNUMBER),
            CODCONTRATO        =nvl(p_codcontrato,CODCONTRATO)
           
     WHERE  ID_CONTADOR=p_id_contador;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CONTADOR',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: El contador a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_VALORP_NOEXISTE THEN
        resultado := 'KO: La direccion o tipo contador no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CONTADOR no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CONTADOR',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA CONTADOR',p_entrada,' ', resultado);
      COMMIT;
END PR_MODI_CONTADOR;  
  
  
  
  
/*********************************************************************************
PROCEDURE PR_ALTA_TMODELO Realiza el alta de la tabla T_MODELO
Es obligatorio introducir los campos necesario y que el modelo de contador no exista.

Parametros de entrada:         p_modelo           opcional
                               p_fechafab         opcional
                               p_empresafab       opcional
                               p_caracteristicas  opcional
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_T_MODELO( p_modelo           IN T_MODELO.MODELO%TYPE,
                           p_fechafab         IN T_MODELO.FECHA_FABRICA%TYPE, 
                           p_empresafab       IN T_MODELO.EMPRESAFAB%TYPE,
                           p_caracteristicas  IN T_MODELO.CARACTERISTICAS%TYPE,    
                           resultado            OUT VARCHAR2)
IS
  /* Declaramos variables locales*/
  
   E_CAMPO_VACIO           EXCEPTION;
   E_CONTADOR_EXISTE      EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(1000);

BEGIN
     	p_entrada:= 'MODELO: '||p_modelo||', FECHA FABRICA:'||p_fechafab||', EMPRESA FABRICA:'||p_empresafab||',CARACTERISTICAS:'||p_caracteristicas;

      IF (TRIM(p_modelo)IS NULL)
        THEN
         RAISE E_CAMPO_VACIO;
      END IF;   	

     /*Verifica que no exista el contador */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_MODELO
       	       	WHERE ((MODELO=p_modelo)and(FECHA_FABRICA=p_fechafab)and(EMPRESAFAB=empresafab)) 
          	AND ROWNUM  = 1;
          	RAISE E_CONTADOR_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla direccciones y rellenamos el LOG*/

      INSERT INTO T_MODELO (MODELO,FECHA_FABRICA,T_MODELO.EMPRESAFAB,CARACTERISTICAS)
           VALUES (p_modelo, p_fechafab, p_empresafab,p_caracteristicas);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO MODELO',p_entrada,' ', resultado);
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_CONTADOR_EXISTE THEN
      resultado := 'KO: El tipo de contador ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO MODELO',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO MODELO',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA TIPO MODELO',p_entrada,' ', resultado);
      COMMIT;

  END PR_ALTA_T_MODELO; 
  
  
  /*************************************************************************
PROCEDURE PR_BAJA_T_MODELO Realiza la baja de un registro de la tabla T_MODELO

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_modelo   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_T_MODELO ( p_id_modelo IN T_MODELO.ID_MODELO%TYPE,
                                resultado       OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_MODELO: '||p_id_modelo;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_modelo)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_MODELO
        WHERE ID_MODELO = p_id_modelo
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_MODELO
   	WHERE ID_MODELO = p_id_modelo;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO MODELO CONTADOR',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: El modelo contador a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO MODELO CONTADOR',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_MODELO no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO MODELO CONTADOR',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA TIPO MODELO CONTADOR',p_entrada,' ', resultado);

        COMMIT; 

  END PR_BAJA_T_MODELO;
  
  
/*************************************************************************
PROCEDURE PR_MODI_TMODELO Modifica un registro de la tabla T_TMODELO

Es obligatorio introducir los campos necesario y que el tipo modelo exista.

Parametros de entrada:         p_modelo           opcional
                               p_fechafab         opcional
                               p_empresafab       opcional
                               p_caracteristicas  opcional
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: El modelo contador no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_T_MODELO (p_id_modelo         IN  T_MODELO.ID_MODELO%TYPE,
                           p_modelo           IN T_MODELO.MODELO%TYPE,
                           p_fechafab         IN T_MODELO.FECHA_FABRICA%TYPE, 
                           p_empresafab       IN T_MODELO.EMPRESAFAB%TYPE,
                           p_caracteristicas  IN T_MODELO.CARACTERISTICAS%TYPE,    
                           resultado            OUT VARCHAR2)
                           
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN
    p_entrada:= 'ID MODELO: '||p_id_modelo||', MODELO: '||p_modelo||', FECHA FABRICA:'||p_fechafab||', EMPRESA FABRICA:'||p_empresafab||',CARACTERISTICAS:'||p_caracteristicas;
    
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_modelo)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la central exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_MODELO
        WHERE ID_MODELO=p_id_modelo
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

     UPDATE T_MODELO
        SET MODELO           =nvl(p_modelo,MODELO),
            FECHA_FABRICA    =nvl(p_fechafab,FECHA_FABRICA),
            EMPRESAFAB       =nvl(p_empresafab,EMPRESAFAB),
            CARACTERISTICAS  =nvl(p_caracteristicas,CARACTERISTICAS)

     WHERE  ID_MODELO=p_id_modelo;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA MODELO CONTADOR',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: El modelo contador a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA MODELO CONTADOR',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CONTADOR no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA MODELO CONTADOR',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA MODELO CONTADOR',p_entrada,' ', resultado);
      COMMIT;
      
END PR_MODI_T_MODELO;                           
                           
                           
/*********************************************************************************
PROCEDURE PR_ALTA_CONCENTRALES Realiza el alta de la tabla T_CON_CENTRALES
Es obligatorio introducir los campos necesario y que el modelo de contador no exista.

Parametros de entrada:         id_contador        Necesario
                               id_centraldis      Necesario
	Modifica:	       resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion ya existe'
                'KO:  Error' error de oracle 
*********************************************************************************/
PROCEDURE PR_ALTA_CONCENTRALES(p_id_contador      IN T_CON_CENTRALES.ID_CONTADOR%TYPE,
                               p_id_centraldis    IN T_CON_CENTRALES.ID_CENTRALDIS%TYPE, 
                               resultado            OUT VARCHAR2)
                               
IS
  /* Declaramos variables locales*/
  
   E_CAMPO_VACIO           EXCEPTION;
   E_CONTADOR_EXISTE      EXCEPTION;
   E_CAPACIDAD            EXCEPTION;

    E_VALORP_NOEXISTE  EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada     VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);
   p_id_lineacom NUMBER;
   p_potencia    number;
   POT_A         NUMBER;
   POT_B         NUMBER;

BEGIN
     	p_entrada:= 'ID CONTADOR: '||p_id_contador||', ID CENTRAL DISTRIBUCION: '||p_id_centraldis;

   	

     /*Verifica que  exista la asociacion */

     BEGIN
	       	SELECT 'S'
               	INTO existe
               	FROM T_CON_CENTRALES
       	       	WHERE ((ID_CONTADOR=p_id_contador)and(ID_CENTRALDIS=p_id_centraldis)) 
          	AND ROWNUM  = 1;
          	RAISE E_CONTADOR_EXISTE;
        	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
           	NULL;
      END;
      /*Verifica que exista la central y el contador */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_contador=p_id_contador
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;      
              BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS=p_id_centraldis
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;  
      


         
      
      
      /*Comprobamos que la central de distribucion tenga capacidad para el contador*/
      
      select POTENCIA into POT_A FROM T_CONTADOR WHERE ID_CONTADOR=p_id_contador;
      select (MAXIMODIS-CONSUMO) into POT_B FROM T_CENTRALESDISTRIBUCION WHERE ID_CENTRALDIS=p_id_centraldis;
      
     IF (POT_A)>(POT_B) THEN 
          RAISE E_CAPACIDAD;
      END IF;

      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla contadores y rellenamos el LOG*/

      INSERT INTO T_CON_CENTRALES (ID_CONTADOR,ID_CENTRALDIS)
           VALUES (p_id_contador, p_id_centraldis);

      resultado := 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR-CENTRALES',p_entrada,' ', resultado);
       
      
      
      
      
      COMMIT;

  EXCEPTION
      /*Excepcion en caso que exista la asociacion rellenamos el LOG*/    
    WHEN E_CONTADOR_EXISTE THEN
      resultado := 'KO: La asociacion ya existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR-CENTRALES',p_entrada,' ', resultado);
      COMMIT;
      
    /*Excepcion en caso que exista no exista la central o el contador rellenamos el LOG*/   
     
          WHEN  E_VALORP_NOEXISTE THEN
      resultado := 'KO: El contador o la central no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR-CENTRALES',p_entrada,' ', resultado);
      COMMIT;
         /*Excepcion en caso que exista la direccion rellenamos el LOG*/    
    WHEN E_CAPACIDAD THEN
      resultado := 'KO: La central no tiene capacidad para esa potencia';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR-CENTRALES',p_entrada,' ', resultado);
      COMMIT;
      
      
    /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
    WHEN E_CAMPO_VACIO THEN
     resultado := 'KO: Se ha de informar el campo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CON_CENETRALES',p_entrada,' ', resultado);
      COMMIT;
    /*Excepcion de otros casos de error rellenamos el LOG*/
    WHEN OTHERS THEN
      err_num := SQLCODE;
      err_msg := SUBSTR(SQLERRM, 1, 200);

      resultado:= 'KO: '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CON_CENETRALES',p_entrada,' ', resultado);
      COMMIT;
      
END PR_ALTA_CONCENTRALES; 

/*************************************************************************
PROCEDURE PR_BAJA_CONCENTRALES Realiza la baja de un registro de la tabla T_CON_CENTRALES

Es obligatorio introducir los campos necesario y que el contador exista.

Parametros de entrada:           p_id_con_centrales   Necesaria
	Modifica:		 resultado    
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_BAJA_CONCENTRALES ( p_id_con_centrales IN T_CON_CENTRALES.ID_CON_CENTRALES%TYPE,
                                resultado       OUT VARCHAR2)
                                
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO EXCEPTION;
   E_VALOR_NOEXISTE EXCEPTION;

   existe        VARCHAR2(1);
   p_entrada VARCHAR2(1000);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

      p_entrada := 'ID_CONCENTRALES: '||p_id_con_centrales;

     /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_con_centrales)IS NULL)
     THEN
         RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que no exista la central */

     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CON_CENTRALES
        WHERE ID_CON_CENTRALES = p_id_con_centrales
          AND ROWNUM   = 1;

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;


      /*Si no ha habido excepcion en este punto realizamos la eliminacion del registro de la tabla  y rellenamos el LOG*/

	DELETE FROM T_CON_CENTRALES
   	WHERE ID_CON_CENTRALES = p_id_con_centrales;


      resultado:= 'OK';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR-CENTRALES',p_entrada,' ', resultado);
      COMMIT;

      /*Excepcion en caso que la asociacion no exista rellenamos el LOG*/ 

   EXCEPTION
      WHEN E_VALOR_NOEXISTE THEN
        resultado:= 'KO: La asociacion a borrar no existe';

      INSERT INTO T_LOG(FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR-CENTRALES',p_entrada,' ', resultado);

        COMMIT;
  
     /*Excepcion en caso que falte campo obligatorio rellenamos el LOG*/
      WHEN E_CAMPO_VACIO THEN
        resultado:= 'KO: El campo ID_CON_CENTRALES no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR-CENTRALES',p_entrada,' ', resultado);

        COMMIT;
     /*Excepcion de otros casos de error rellenamos el LOG*/
     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);

        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'BAJA CONTADOR-CENTRALES',p_entrada,' ', resultado);

        COMMIT; 

  END PR_BAJA_CONCENTRALES;

/*************************************************************************
PROCEDURE PR_MODI_CONCENTRALES Modifica un registro de la tabla T_CONCENTRALES

Es obligatorio introducir los campos necesario y que el tipo modelo exista.

Parametros de entrada:         id_con_centrales   Necesario
                               id_contador        Opcional
                               id_centraldis      Opcional
	Modifica:	       resultado        
        Valor de resultado:
                'OK' si se ha realizado con exito
        Posibles errores   
                'KO: Se ha de informar el campo'
                'KO: La asociacion no existe'
                'KO:  Error' error de oracle 
***********************************************************************/                                 
PROCEDURE PR_MODI_CONCENTRALES ( p_id_con_centrales IN T_CON_CENTRALES.ID_CON_CENTRALES%TYPE,
                                 p_id_contador      IN T_CON_CENTRALES.ID_CONTADOR%TYPE,
                                 p_id_centraldis    IN T_CON_CENTRALES.ID_CENTRALDIS%TYPE, 
                                 resultado            OUT VARCHAR2)
IS
/* Declaramos variables locales*/

   E_CAMPO_VACIO          EXCEPTION;
   E_VALOR_NOEXISTE       EXCEPTION;
    E_VALORP_NOEXISTE  EXCEPTION;
   existe        VARCHAR2(1);
   p_entrada VARCHAR2(500);
   err_num       NUMBER;
   err_msg       VARCHAR2(100);


   BEGIN

    p_entrada:= 'ID CON CENTRALES: '||p_id_con_centrales||', ID CONTADOR: '||p_id_contador||', ID CENTRAL DISTRIBUCION: '||p_id_centraldis;
        
         /*Verifica que todos los campos obligatorios tengan valor */

     IF (TRIM(p_id_con_centrales)IS NULL)
     THEN
     RAISE E_CAMPO_VACIO;
      END IF;

     /*Verifica que la asociacion exista*/
     BEGIN

       SELECT 'S'
         INTO existe
         FROM T_CON_CENTRALES
        WHERE ID_CON_CENTRALES=p_id_con_centrales
          AND ROWNUM   = 1;
          
         
      /*Verifica que exista la central y el contador */
        BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CONTADOR
        WHERE ID_contador=p_id_contador
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;      
              BEGIN
       SELECT 'S'
         INTO existe
         FROM T_CENTRALESDISTRIBUCION
        WHERE ID_CENTRALDIS=p_id_centraldis
          AND ROWNUM   = 1;
             	EXCEPTION
        		WHEN NO_DATA_FOUND THEN
                          RAISE E_VALORP_NOEXISTE;
           	
      END;  
      
      

      EXCEPTION
        WHEN NO_DATA_FOUND THEN
           RAISE E_VALOR_NOEXISTE;
      END;
      /*Si no ha habido excepcion en este punto realizamos la inserccion en la tabla y rellenamos el LOG*/

     UPDATE T_CON_CENTRALES
        SET ID_CONTADOR      =nvl(p_id_contador,ID_CONTADOR),
            ID_CENTRALDIS    =nvl(p_id_centraldis,ID_CENTRALDIS)

     WHERE  ID_CON_CENTRALES=p_id_con_centrales;

     resultado := 'OK';
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA ASOCIACION CONTADOR CENTRALES DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

   EXCEPTION
              /*Excepcion en caso que no exista algun parametro rellenamos el LOG*/    
    WHEN E_VALORP_NOEXISTE THEN
      resultado := 'KO: El contador o la central no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'ALTA CONTADOR-CENTRALES',p_entrada,' ', resultado);
      COMMIT; 
      
      WHEN E_VALOR_NOEXISTE THEN
        resultado := 'KO: La asociacion a modificar no existe';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA ASOCIACION CONTADOR CENTRALES DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

      WHEN E_CAMPO_VACIO THEN
        resultado := 'KO: El campo ID_CON_CENTRALES no puede ser nulo';

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA ASOCIACION CONTADOR CENTRALES DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;

     WHEN OTHERS THEN
        err_num := SQLCODE;
        err_msg := SUBSTR(SQLERRM, 1, 200);
        resultado:= 'KO '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'MODIFICA ASOCIACION CONTADOR CENTRALES DISTRIBUCION',p_entrada,' ', resultado);
      COMMIT;
      
END PR_MODI_CONCENTRALES;

END "AMBCONTADOR";
/
 