
REM TF2 F_CONSULTA_B

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_B" 
RETURN TYPE_CONSULTA_B AS

SALIDA  TYPE_CONSULTA_B:=TYPE_CONSULTA_B();

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);

 

--Cargamos los registro deseado (UNA SELECT ANIDADA PARA SABER EL ID DE LA cdistri Y MOSTRAR SU SUMA DE CONSUMOS)
CURSOR CUR_CDIS  IS
select distinct T_DIRECCIONES.PAIS as PAIS_CD ,T_DIRECCIONES.LOCALIDAD as LOCALIDAD_CD,
        T_DIRECCIONES.TIPO_VIA as TIPOVIA_CD ,T_DIRECCIONES.VIA as VIA_CD ,
        T_DIRECCIONES.NUMERO as NUM_CD ,T_DIRECCIONES.PISO as PISO, 
        T_CENTRALESDISTRIBUCION.CONSUMO as ENERGIA_CD,
        T_CENTRALESDISTRIBUCION.MAXIMODIS as MAXENER
     from t_centralesproduccion,t_produc_dis,t_centralesdistribucion,t_direcciones      
     where t_centralesproduccion.ID_CENTRALPROD = t_produc_dis.ID_CENTRALPROD and t_produc_dis.ID_CENTRALDIS = t_centralesdistribucion.ID_CENTRALDIS and t_centralesdistribucion.ID_DIRECCION=T_DIRECCIONES.ID_DIRECCION
     AND ROWNUM<11
     Order by 4 desc;


  PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN

 FOR REG1 IN CUR_CDIS LOOP
    SALIDA.EXTEND;
    
    SALIDA(N) := TYPEOBJ_CONSULTA_B(REG1.PAIS_CD, REG1.LOCALIDAD_CD,
    REG1.TIPOVIA_CD, REG1.VIA_CD, REG1.NUM_CD,REG1.PISO,REG1.ENERGIA_CD,REG1.MAXENER);
    
    N:=N+1;
   
  END LOOP;
 
  -- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA B',' ',' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA A',' ',' ', resultado);
      COMMIT;   

  RETURN (SALIDA);
  
END;
/
 
REM TF2 F_CONSULTA_A

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_A" 

 (p_localidad   IN T_DIRECCIONES.LOCALIDAD%TYPE, p_mes date)
RETURN TYPE_CONSULTA_A 
as
   N NUMBER:=1;
   Consumo_medio NUMBER:=0;
   valor NUMBER:=0;
   
   SALIDA  TYPE_CONSULTA_A:=TYPE_CONSULTA_A();
 
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
   p_entrada         VARCHAR2(1500);
    LECTURAMAX       NUMBER;
    LECTURAMIN       NUMBER;
    LECTURA          NUMBER;
    TOTAL            NUMBER;
     consumo         NUMBER;
     conta           NUMBER;
    consumomedio     NUMBER; 
 --Cargamos los registros contador  deseados
CURSOR CUR_CONTADOR (pp_localidad T_DIRECCIONES.LOCALIDAD%TYPE, pp_mes date) IS
--Calculamos el consumo medio

 select DISTINCT T_CONTADOR.CODCONTRATO as CODICONTRACTE, T_CONTADOR.POTENCIA as POT_MAX_CONTRATADA,T_CONTADOR.CONSUMOMEN as PORCEN_CONSUMODMEDIO_CONSUMIDO
from T_DIRECCIONES ,T_CONTADOR , T_LECTURAS
where	 T_CONTADOR.ID_DIRECCION = T_DIRECCIONES.ID_DIRECCION and localidad=pp_localidad
Order by 3 desc;

  PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN
consumomedio:=0;
N:=1;
p_entrada:='Fecha:'||p_mes|| ', Localidad: '||p_localidad;
--Calculamos el consumo medio
  FOR REG1 IN CUR_CONTADOR(p_localidad,p_mes) LOOP
  
    select id_contador into conta
    from t_contador 
    where REG1.CODICONTRACTE=codcontrato;
    
    select max(distinct T_LECTURAS.LECTURA) into lecturamax
    from T_LECTURAS,T_DIRECCIONES,T_CONTADOR
    where conta=T_LECTURAS.ID_CONTADOR and T_LECTURAS.ID_CONTADOR=T_CONTADOR.ID_CONTADOR and T_CONTADOR.ID_DIRECCION=T_DIRECCIONES.ID_DIRECCION
    and T_DIRECCIONES.LOCALIDAD = p_localidad	  and
    (select extract(month from p_mes)from dual )=( select extract(month from fechalec) from dual) and
    (select extract(year from p_mes)from dual )=( select extract(year from fechalec) from dual);
 
    select max(distinct T_LECTURAS.LECTURA) into lecturamin
    from T_LECTURAS,T_DIRECCIONES,T_CONTADOR
    where conta=T_LECTURAS.ID_CONTADOR and  T_LECTURAS.ID_CONTADOR=T_CONTADOR.ID_CONTADOR and T_CONTADOR.ID_DIRECCION=T_DIRECCIONES.ID_DIRECCION
    and T_DIRECCIONES.LOCALIDAD = p_localidad	  and
    (select extract(month from (SELECT add_months(p_mes,-1) FROM dual))from dual )=( select extract(month from fechalec) from dual) and
    (select extract(year from  (SELECT add_months(p_mes,-1) FROM dual))from dual )=( select extract(year from fechalec) from dual);

if lecturamin is null then lecturamin:=0; end if;
if lecturamax is null then lecturamax:=0;lecturamin:=0; end if;

consumomedio:=consumomedio+(lecturamax-lecturamin);

END LOOP;

select count(DISTINCT T_CONTADOR.CODCONTRATO) into conta
from T_DIRECCIONES ,T_CONTADOR , T_LECTURAS
where	 T_CONTADOR.ID_DIRECCION = T_DIRECCIONES.ID_DIRECCION and localidad=p_localidad;
if conta is null then 
  consumomedio:=1; 
else   
  consumomedio:=consumomedio/conta ;    
end if;

  FOR REG1 IN CUR_CONTADOR(p_localidad,p_mes) LOOP
    
    select id_contador into conta
    from t_contador 
    where REG1.CODICONTRACTE=codcontrato;
    
     select max(distinct T_LECTURAS.LECTURA) into lecturamax
    from T_LECTURAS,T_DIRECCIONES,T_CONTADOR
    where conta=T_LECTURAS.ID_CONTADOR and T_CONTADOR.ID_DIRECCION=T_DIRECCIONES.ID_DIRECCION
    and T_DIRECCIONES.LOCALIDAD = p_localidad  and
    (select extract(month from p_mes)from dual )=( select extract(month from fechalec) from dual) and
    (select extract(year from p_mes)from dual )=( select extract(year from fechalec) from dual);

    select max(distinct T_LECTURAS.LECTURA) into lecturamin
    from T_LECTURAS,T_DIRECCIONES,T_CONTADOR
    where conta=T_LECTURAS.ID_CONTADOR and T_CONTADOR.ID_DIRECCION=T_DIRECCIONES.ID_DIRECCION
    and T_DIRECCIONES.LOCALIDAD = p_localidad	  and
    (select extract(month from     (SELECT add_months(p_mes,-1) FROM dual))from dual )=( select extract(month from fechalec) from dual) and
    (select extract(year from     (SELECT add_months(p_mes,-1) FROM dual))from dual )=( select extract(year from fechalec) from dual);

if lecturamin is null then lecturamin:=0; end if;
if lecturamax is null then lecturamax:=0;lecturamin:=0; end if;
--En base al consumo guardamos o no en la salida de la funcion
consumo:=lecturamax-lecturamin;    
    if (consumo > (consumo_medio*0.8)) then 
        consumo:=consumo*100/consumomedio;
        SALIDA.EXTEND;    
        SALIDA(N) := TYPEOBJ_CONSULTA_A(REG1.CODICONTRACTE, REG1.POT_MAX_CONTRATADA ,consumo);
        N:=N+1;
    end if;
    
  END LOOP;
  -- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA A',p_entrada,' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA A',p_entrada,' ', resultado);
      COMMIT;        
RETURN (SALIDA);
END;
/
 
REM TF2 F_CONSULTA_G

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_G" (amos NUMBER)
RETURN TYPE_CONSULTA_G AS

SALIDA  TYPE_CONSULTA_G:=TYPE_CONSULTA_G();

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
   ano               NUMBER;


--Cargamos los valores de contador
CURSOR CONTAD  (p_amos number) IS
select ID_CONTADOR as CONTADOES ,FECHA_INSTALACION as F_INSTALADO
     from T_CONTADOR
     where (((select extract(year from sysdate)from dual)-(select extract(year from FECHA_INSTALACION)from dual))>=p_amos)
     Order by 2 desc;
  PRAGMA AUTONOMOUS_TRANSACTION;


 
BEGIN


 FOR REG1 IN CONTAD(amos) LOOP
    SALIDA.EXTEND;
    SALIDA(N) := TYPEOBJ_CONSULTA_G(REG1.CONTADOES, REG1.F_INSTALADO);
    N:=N+1;
   
  END LOOP;
 
  -- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA G',' ',' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA G',' ',' ', resultado);
      COMMIT;   

  RETURN (SALIDA);
  
END;
/
 
REM TF2 F_CONSULTA_D

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_D" 
RETURN TYPE_CONSULTA_D AS

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
   
   SALIDA  TYPE_CONSULTA_D:=TYPE_CONSULTA_D();
   
CURSOR CLIENTE IS
--Caargamos el cursor con la select

select DISTINCT NIF as DNI_CLIENTE, CODCONTRATO  as CODIGO_CONTRATO,MODELO as MODELO_CONTADOR
from T_MODELO,T_CONTADOR,T_CLIENTES,T_CLIENTECONTADOR,T_PRODUC_DIS,T_CENTRALESDISTRIBUCION,T_CON_CENTRALES
where T_CLIENTECONTADOR.ID_NIF=T_CLIENTES.ID_NIF and T_CLIENTECONTADOR.ID_CONTADOR=T_CONTADOR.ID_CONTADOR and 
T_CONTADOR.ID_CONTADOR=T_CON_CENTRALES.ID_CONTADOR and T_CON_CENTRALES.ID_CENTRALDIS=T_PRODUC_DIS.ID_CENTRALDIS and T_CONTADOR.ID_CONTADOR=T_CLIENTECONTADOR.ID_CONTADOR 
 
Order by 1;
   
 PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN
  FOR REG1 IN CLIENTE LOOP
    SALIDA.EXTEND;
        SALIDA(N) := TYPEOBJ_CONSULTA_D(REG1.DNI_CLIENTE,REG1.CODIGO_CONTRATO,REG1.MODELO_CONTADOR);
      N:=N+1;
  END LOOP;

  -- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA D',' ',' ', resultado);
      COMMIT;
  
  RETURN SALIDA;  
  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA D',' ',' ', resultado);
      COMMIT;   
  
  RETURN SALIDA;

END;
/
 
REM TF2 F_CONSULTA_C

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_C" 
RETURN TYPE_CONSULTA_C AS

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
   
   SALIDA  TYPE_CONSULTA_C:=TYPE_CONSULTA_C();
   
CURSOR LINEA IS
--Caargamos el cursor con la select

select ID_LINEACOM as CODI_IDENTIFICACIO, (CONSUMOLINEA/CAPACIDADMAX) as CARREGA_DE_LA_LINEA,(CAPACIDADMAX-CONSUMOLINEA) as ENERGIA_PER_AMPLIAR
from T_LINEASCOMUNIC
where rownum<11
order by 2 desc;
      
  PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN
  FOR REG1 IN LINEA LOOP
    SALIDA.EXTEND;
    
    SALIDA(N) := TYPEOBJ_CONSULTA_C(REG1.CODI_IDENTIFICACIO, REG1.CARREGA_DE_LA_LINEA,REG1.ENERGIA_PER_AMPLIAR);
    
    N:=N+1;
   
  END LOOP;
 
-- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA C',' ',' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA C',' ',' ', resultado);
      COMMIT;   

  RETURN (SALIDA);
  
END;
/
 
REM TF2 F_CONSULTA_E

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_E" 
 (p_CENTRAL_PROD NUMBER, p_inicio in date, p_fin in date)
RETURN TYPE_CONSULTA_E AS

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
    p_entrada         VARCHAR2(1500);
   mes              NUMBER;
   x                NUMBER;
   y                NUMBER;
   z                NUMBER;
   contad   NUMBER;
   maxi      NUMBER;

   SALIDA  TYPE_CONSULTA_E:=TYPE_CONSULTA_E();
   
   
CURSOR L(pa_central_PROD NUMBER, pa_inicio date, pa_fin date) IS

select distinct t_CONTADOR.ID_CONTADOR as CONSUMO_CONTADORES,1 as ENERGIA_PRODUCIDA
from T_CONTADOR, T_CON_CENTRALES, T_PRODUC_DIS, T_LECTURAS,T_CENTRALESPRODUCCION
where p_central_prod=t_produc_dis.id_centralprod and t_produc_dis.id_centraldis=t_con_centrales.id_centraldis and t_con_centrales.id_contador=t_CONTADOR.ID_CONTADOR;

     
  PRAGMA AUTONOMOUS_TRANSACTION;

BEGIN

p_entrada:='Central de producciÃƒÆ’Ã†â€™Ãƒâ€šÃ‚Â³n :'||p_CENTRAL_PROD|| ', Fecha inicio:'||p_inicio|| ', Fecha fin:  '||p_fin;

mes:=ceil(months_between(p_fin,p_inicio));

if mes=0 then mes:=1; end if; 
Z:=0;

SELECT ENERGIAMAX into MAXI from t_CENTRALESPRODUCCION where p_CENTRAL_PROD=ID_CENTRALPROD;
mes:= mes * MAXI ;

  FOR REG1 IN L (p_CENTRAL_PROD, p_inicio, p_fin) LOOP
    
    select max(lectura) into x
    from T_CONTADOR, T_CON_CENTRALES, T_PRODUC_DIS, T_LECTURAS
    where REG1.CONSUMO_CONTADORES=t_lecturas.ID_CONTADOR
    and T_LECTURAS.FECHALEC between p_inicio AND p_fin ;

    select max(lectura) into y
    from T_CONTADOR, T_CON_CENTRALES, T_PRODUC_DIS, T_LECTURAS
    where REG1.CONSUMO_CONTADORES=t_lecturas.ID_CONTADOR
   and T_LECTURAS.FECHALEC<p_inicio;

if y is null then y:=0; end if;
Z:=z+x-y;
    
    
    
    SALIDA.EXTEND;
    
    SALIDA(N) := TYPEOBJ_CONSULTA_E(z,REG1.ENERGIA_PRODUCIDA*mes );
    
   
   
  END LOOP;
 -- Grabamos el log  
  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA E',p_entrada,' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA E',p_entrada,' ', resultado);
      COMMIT;   

  RETURN (SALIDA);
  
END;
/
 
REM TF2 F_CONSULTA_F

  CREATE OR REPLACE FUNCTION "TF2"."F_CONSULTA_F" 
RETURN TYPE_CONSULTA_F AS

SALIDA  TYPE_CONSULTA_F:=TYPE_CONSULTA_F();

   N NUMBER:=1;
   resultado         VARCHAR2(2000);
   err_num           NUMBER;
   err_msg           VARCHAR2(100);
   total               NUMBER;
   te                 NUMBER; 
   ta                 NUMBER;


--Cargamos los valores de lecturas
CURSOR TELE  IS

select distinct 1 as PRESENCIALES, 1 as NO_PRESENCIALES
from T_LECTURAS
where telematica>0;


  PRAGMA AUTONOMOUS_TRANSACTION;

 
BEGIN
select count(telematica) into total from t_lecturas;
select count(telematica) into te  from t_lecturas where telematica>0;
ta:=total-te;

 FOR REG1 IN TELE LOOP
    SALIDA.EXTEND;
    SALIDA(N) := TYPEOBJ_CONSULTA_F(REG1.PRESENCIALES*ta/total*100,REG1.PRESENCIALES*te/total*100);
    N:=N+1;
 END LOOP;
 
  -- Grabamos el log  
  resultado := 'OK';  

      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA F',' ',' ', resultado);
      COMMIT;
  
  RETURN SALIDA;

  
EXCEPTION

  WHEN OTHERS THEN
     err_num := SQLCODE;
     err_msg := SUBSTR(SQLERRM, 1, 200);
     resultado:= 'ERROR '||TO_CHAR(err_num)||': '||err_msg;
      INSERT INTO T_LOG (FECHA, PROCEDIMIENTO, ENTRADA, SALIDA, RESULTADO)
      VALUES (SYSDATE,'CONSULTA F',' ',' ', resultado);
      COMMIT;   

  RETURN (SALIDA);
  
END;
/
 